SUBROUTINE Adrianne_thread_state

   USE global_variables
   IMPLICIT NONE

   INTEGER :: i,j,istate
   INTEGER :: check_adrianne

   nAdrianneStates = nAdrianneStates+1 
   ! Save the new state of Sudoku puzzle till it is solved from
   ! the previous state
   sudoku_Adrianne(nAdrianneStates,:,:) = sudoku
   sudoku_Adrianne_logic(nAdrianneStates,:,:,:) = sudoku_logic
   sudoku_Adrianne_logic_numbers(nAdrianneStates,:,:) = sudoku_logic_numbers

   ! Find a square and a number to start Adrianne's Thread
iloop:   DO i=1,9
     DO j=1,9
	IF (sudoku(i,j) .ne. 0) CYCLE
	  ! Make sure it is not one of the previous cells of the
	  ! Adrianne's Thread array
	  check_adrianne = 0
	  DO istate=1,nAdrianneStates-1
	     IF ((i .eq. Adrianne_state_row(istate)) .AND. &
		  (j .eq. Adrianne_state_col(istate))) THEN
		 	check_adrianne = 1
			EXIT
	     END IF
	  END DO
	  IF (check_adrianne .eq. 0) THEN
		Adrianne_state_row(nAdrianneStates) = i
		Adrianne_state_col(nAdrianneStates) = j
		EXIT iloop
	  END IF 	
     END DO
  END DO iloop

END SUBROUTINE Adrianne_thread_state

!-----------------------------------------------------

SUBROUTINE check_contradiction_Adrianne(sudoku,check_adrianne)

  IMPLICIT NONE

  INTEGER, DIMENSION(9,9) :: sudoku
  INTEGER :: check_adrianne

  INTEGER,DIMENSION(9) :: row_check,col_check,smallcell_check
  INTEGER :: i,j,inumber
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: row_k,column_k,ii_other,jj_other

  ! Do it for each row
  DO i=1,9
    row_check = 0
    DO j=1,9
      IF (sudoku(i,j) .eq. 0) CYCLE
      row_check(sudoku(i,j)) = row_check(sudoku(i,j)) + 1
    END DO
    DO inumber=1,9
      IF(row_check(inumber) .gt. 1) THEN
         check_adrianne = 1
         RETURN
      END IF
    END DO
  END DO

  ! Do it for each column
  DO j=1,9
    col_check = 0
    DO i=1,9
      IF (sudoku(i,j) .eq. 0) CYCLE
      col_check(sudoku(i,j)) = col_check(sudoku(i,j)) + 1
    END DO
    DO inumber=1,9
      IF(col_check(inumber) .gt. 1) THEN
         check_adrianne = 1
         RETURN
      END IF
    END DO
  END DO

  ! Do it for smallcell
  DO i=1,9
    DO j=1,9
      smallcell_check = 0

!      IF (sudoku(i,j) .ne. 0) CYCLE
      ! Find the small cell to which this cell belongs
      IF (mod(i,3) .ne. 0) THEN
        small_cell_row = int(i/3)+1
      ELSE
        small_cell_row = int(i/3)
      END IF
      IF (mod(j,3) .ne. 0) THEN
        small_cell_column = int(j/3)+1
      ELSE
        small_cell_column = int(j/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

   DO ii_other=row_k,row_k+2
     DO jj_other=column_k,column_k+2
        IF (sudoku(ii_other,jj_other) .ne. 0) THEN
          smallcell_check(sudoku(ii_other,jj_other)) = smallcell_check(sudoku(ii_other,jj_other))+1
        END IF
      END DO
     END DO

    DO inumber=1,9
      IF(smallcell_check(inumber) .gt. 1) THEN
         check_adrianne = 1
         RETURN
      END IF
    END DO

  END DO
 END DO


END SUBROUTINE check_contradiction_Adrianne

!-----------------------------------------------------------------------------------

