!-------------------------------------------------------------------------
! initial-28 and initial-24 are used to test Bug hunting
! Bug hunting where one unsolvled square has polyvalue and all other 
! unsolved squares has 2 values..  
! The row, column and block contains each unsolved possibility exactly
! twice..
! Call Forced moves and pinned moves before calling Bug hunting.. 
! Make sure all the squares that have only one possibility are solved
! i.e. no square should have sudoku_logic_numbers = 1
!-----------------------------------------------------------------------
SUBROUTINE Bug_hunting

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i,j,check_bug
  INTEGER :: cell_ij_numbers,cell_ij_logic_number
  INTEGER,DIMENSION(9) :: temp_array,temp_array1,temp_array_check
  INTEGER,DIMENSION(100) :: check_bug_row,check_bug_column
  INTEGER :: inumber,jnumber,knumber
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: iblock,check_block,check_bug_block
  INTEGER :: ii_other,jj_other
  INTEGER :: check_ii_other,check_jj_other
  INTEGER :: iblock_row,iblock_column
  INTEGER :: temp_number,temp_number_check
  INTEGER :: sudoku_logic_numbers_old
  INTEGER,DIMENSION(9) :: sudoku_logic_old

! Each square has 2 possibilities except one polyvalue square
  check_bug = 0
  DO i=1,9
    DO j=1,9
      IF (sudoku(i,j) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i,j)
      IF (cell_ij_numbers .gt. 2) THEN
	check_bug = check_bug+1
	check_bug_row(check_bug) = i
	check_bug_column(check_bug) = j
      END IF
    END DO
  END DO

  IF (check_bug .ne. 1) THEN
!	write(*,*) 'RETURNING FROM BUG HUNTING - 1'
	RETURN
  END IF
 
  ! Find the block of the bug square
  IF (mod(check_bug_row(1),3) .ne. 0) THEN
    small_cell_row = int (check_bug_row(1)/3)+1
  ELSE
    small_cell_row = int(check_bug_row(1)/3)
  END IF
  IF (mod(check_bug_column(1),3) .ne. 0) THEN
    small_cell_column = int(check_bug_column(1)/3)+1
  ELSE
    small_cell_column = int(check_bug_column(1)/3)
  END IF
  check_bug_block = (small_cell_row-1)*3+small_cell_column
  
   
  ! All the unsolved squres have 2 possibilities 	 
  ! Loop over rows
  DO i=1,9
    IF (i .eq. check_bug_row(1)) CYCLE
    temp_array = 0
    DO j=1,9
      IF (sudoku(i,j) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i,j)
      DO inumber=1,cell_ij_numbers
	cell_ij_logic_number = sudoku_logic(i,j,inumber)
        temp_array(cell_ij_logic_number) = temp_array(cell_ij_logic_number)+1
      END DO  
    END DO
    DO inumber=1,9
      IF (temp_array(inumber) .gt. 0) THEN
        IF (temp_array(inumber) .ne. 2) THEN
!	  write(*,*) 'RETURNING FROM BUG HUNTING --2'
	  RETURN
	END IF
      END IF
    END DO
  END DO

  ! Loop over columns
  DO j=1,9
    IF (j .eq. check_bug_column(1)) CYCLE
    temp_array = 0
    DO i=1,9
      IF (sudoku(i,j) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i,j)
      DO jnumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i,j,jnumber)
	temp_array(cell_ij_logic_number) = temp_array(cell_ij_logic_number)+1
      END DO
    END DO
      DO jnumber=1,9
        IF (temp_array(jnumber) .gt. 0) THEN
	  IF (temp_array(jnumber) .ne. 2) THEN
!	    write(*,*) 'RETURNING FROM BUG HUNTING --3'
	    RETURN
	  END IF
	END IF
      END DO
   END DO

   ! Loop over blocks 
   DO iblock=1,9
     IF (iblock .eq. check_bug_block) CYCLE
     temp_array=0
     iblock_column=mod(iblock,3)
     IF (iblock_column .ne. 0) THEN
       iblock_row = (iblock/3)+1
     ELSE
	iblock_row = (iblock/3)
     END IF
     IF (iblock_column .eq. 0) THEN
	iblock_column=3
     END IF 

     check_ii_other = (iblock_row-1)*3+1
     check_jj_other = (iblock_column-1)*3+1

     DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
       DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
   	 IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
         cell_ij_numbers=sudoku(ii_other,jj_other)
	 DO knumber=1,cell_ij_numbers
	   cell_ij_logic_number=sudoku_logic(ii_other,jj_other,knumber)
	   temp_array(cell_ij_logic_number)=temp_array(cell_ij_logic_number)+1
	 END DO
       END DO
      END DO

      DO knumber=1,9
	IF (temp_array(knumber) .gt. 0) THEN
	  IF (temp_array(knumber) .ne. 2) THEN
!            write(*,*) 'RETURNING FROM BUG HUNTING --4'
            RETURN
	  END IF
	END IF
      END DO
    END DO
   
! If the execution comes here then it means we have a bug hunting possibility
! One square has more than 2 possibilites.. other squares have 2 possibilities
! in the row, column and block 

  temp_array=0
  DO j=1,9
    IF (sudoku(check_bug_row(1),j) .ne. 0) CYCLE
    cell_ij_numbers=sudoku_logic_numbers(check_bug_row(1),j)
    DO inumber=1,cell_ij_numbers
      cell_ij_logic_number=sudoku_logic(check_bug_row(1),j,inumber)
      temp_array(cell_ij_logic_number)=temp_array(cell_ij_logic_number)+1
    END DO
  END DO

  ! check the sudoku_logic values of the polyvalue square
  temp_array1=0
  temp_number=0
  temp_number_check=0
  temp_array_check = 0
  cell_ij_numbers=sudoku_logic_numbers(check_bug_row(1),check_bug_column(1))
  DO inumber=1,cell_ij_numbers
    cell_ij_logic_number=sudoku_logic(check_bug_row(1),check_bug_column(1),inumber)
    IF (temp_array(cell_ij_logic_number) .eq. 2) THEN
	temp_number_check=temp_number_check+1
	temp_array_check(temp_number_check) = cell_ij_logic_number
    ELSE
      temp_number=temp_number+1
      temp_array1(temp_number) = cell_ij_logic_number
    END IF
  END DO

  ! store the old sudoku_logic_numbers and sudoku_logic array values
  sudoku_logic_numbers_old = sudoku_logic_numbers(check_bug_row(1),check_bug_column(1))
  DO inumber=1,sudoku_logic_numbers_old
    cell_ij_logic_number=sudoku_logic(check_bug_row(1),check_bug_column(1),inumber)
    sudoku_logic_old(inumber)=cell_ij_logic_number
  END DO

! Check if we can get a bug sudoku by making the polyvalue square to a bivalue square
  IF (temp_number_check .ne. 2) THEN
!	write(*,*) 'RETURNING FROM BUG HUNTING -- 5'
	RETURN
  END IF
  DO inumber=1,sudoku_logic_numbers(check_bug_row(1),check_bug_column(1))
    sudoku_logic(check_bug_row(1),check_bug_column(1),inumber)=0
  END DO
  sudoku_logic_numbers(check_bug_row(1),check_bug_column(1)) = temp_number_check
  DO inumber=1,temp_number_check
    sudoku_logic(check_bug_row(1),check_bug_column(1),inumber) = temp_array_check(inumber)
  END DO

! Check if we get a bug in the row (by making the polyvalue square a bivalue square)
  temp_array=0
  DO j=1,9
    IF (sudoku(check_bug_row(1),j) .ne. 0) CYCLE
    cell_ij_numbers=sudoku_logic_numbers(check_bug_row(1),j)
    DO inumber=1,cell_ij_numbers
      cell_ij_logic_number=sudoku_logic(check_bug_row(1),j,inumber)
      temp_array(cell_ij_logic_number)=temp_array(cell_ij_logic_number)+1
    END DO
  END DO
      DO knumber=1,9
        IF (temp_array(knumber) .gt. 0) THEN
          IF (temp_array(knumber) .ne. 2) THEN
! IMP :: if we do not get a bug sudoku, then replace the sudoku logic numbers and sudoku
! logic array value to its old values
	    sudoku_logic_numbers(check_bug_row(1),check_bug_column(1)) = sudoku_logic_numbers_old
            DO i=1,sudoku_logic_numbers_old
	      cell_ij_logic_number=sudoku_logic_old(i)
	      sudoku_logic(check_bug_row(1),check_bug_column(1),i) = cell_ij_logic_number
            END DO
!            write(*,*) 'RETURNING FROM BUG HUNTING --6'
            RETURN
          END IF
        END IF
      END DO

! IMP: check if we get a bug in the column.. if we do not get a bug in the column then
! replace sudoku logic numbers and sudoku logic array value to its old values

! IMP : check if we get a bug in the block.. if we do not get a bug in the block then 
! replace sudoku logic numbers and sudoku logic array value to its old values



  ! Update the sudoku_logic_numbers and sudoku_logic array of polyvalue square
  DO inumber=1,sudoku_logic_numbers(check_bug_row(1),check_bug_column(1))
    sudoku_logic(check_bug_row(1),check_bug_column(1),inumber)=0
  END DO
  sudoku_logic_numbers(check_bug_row(1),check_bug_column(1)) = temp_number
  DO inumber=1,temp_number
    sudoku_logic(check_bug_row(1),check_bug_column(1),inumber) = temp_array1(inumber)
  END DO

! write out the sudoku logic array values of the polyvalue square     
! write out new  sudoku_logic_numbers and sudoku logic values 


END SUBROUTINE Bug_hunting

!--------------------------------------------------------------------------
! initial-9 and initial-10 are initial files for Simple_Xwing
!--------------------------------------------------------------------------
SUBROUTINE Simple_XWing

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row1,i_row2,j_column,i
  INTEGER,DIMENSION(9) :: temp_array1,temp_array2,temp_array3
  INTEGER :: inumber,jnumber,temp_number1,temp_number2,temp_number3
  INTEGER :: cell_ij_numbers,cell_ij_logic_number
  INTEGER,DIMENSION(2) :: xwing1_column,xwing2_column
  INTEGER,DIMENSION(2) :: xwing1_row,xwing2_row
  INTEGER :: j_column1,j_column2,i_row,i_row3,j_column3
 
  ! Find Simple X wing in each row 
  ! Loop over each row
  DO i_row1=1,9
    temp_array1=0
    ! Loop over the columns of the row and find if only 2 squares contain a number
    DO j_column=1,9
	IF (sudoku(i_row1,j_column) .ne. 0) CYCLE
	cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
        DO inumber=1,cell_ij_numbers
	  cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
	  temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
        END DO
     END DO

     ! Loop over the columns again to find the 2 squares that contain that number
     DO jnumber=1,9
	temp_number1=0
	xwing1_column = 0
	IF (temp_array1(jnumber) .eq. 2) THEN
	  DO j_column=1,9 
	    cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
	    DO inumber=1,cell_ij_numbers
	      cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
	      IF (cell_ij_logic_number .eq. jnumber) THEN
		temp_number1=temp_number1+1
		xwing1_column(temp_number1) = j_column
	      END IF
	    END DO
	  END DO

	  DO i_row2=i_row1+1,9
	    temp_array2=0
	    ! Loop over the columns of the row and find if only 2 squares contain that number
  	    DO j_column=1,9
	      IF (sudoku(i_row2,j_column) .ne. 0) CYCLE
	        cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
		DO inumber=1,cell_ij_numbers
		  cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
		  temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
		END DO
	     END DO	

	     temp_number2=0
	     xwing2_column=0
	     ! Cycle over i_row2
	     IF (temp_array2(jnumber) .ne. 2) CYCLE
	     ! If we come here that means the jnumber is shared by 2 squares
	     DO j_column=1,9
	       cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
	       DO inumber=1,cell_ij_numbers
	          cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
		  IF (cell_ij_logic_number .eq. jnumber) THEN
		    temp_number2=temp_number2+1
 		    xwing2_column(temp_number2) = j_column
		  END IF
	       END DO
	     END DO

	     IF ((xwing1_column(1) .eq. xwing2_column(1)) .AND. &
		 (xwing1_column(2) .eq. xwing2_column(2))) THEN
		! We have a Simple X-wing.. Remove this number from other squares
		! of the 2 columns
		! Print the numbers

		DO i_row3=1,9
		  temp_number3=0
		  temp_array3=0
		  IF (sudoku(i_row3,xwing1_column(1)) .ne. 0) CYCLE
		  IF (i_row3 .eq. i_row1) CYCLE
 		  IF (i_row3 .eq. i_row2) CYCLE
		  cell_ij_numbers=sudoku_logic_numbers(i_row3,xwing1_column(1))
		  DO inumber=1,cell_ij_numbers
		    cell_ij_logic_number=sudoku_logic(i_row3,xwing1_column(1),inumber)
		      IF (cell_ij_logic_number .eq. jnumber) CYCLE
		      temp_number3=temp_number3+1
		      temp_array3(temp_number3) = cell_ij_logic_number
		  END DO
		  ! print out the values
		  ! Update the sudoku_logic_numbers and sudoku_logic_array
		  DO inumber=1,cell_ij_numbers
		    sudoku_logic(i_row3,xwing1_column(1),inumber)=0
		  END DO
		  sudoku_logic_numbers(i_row3,xwing1_column(1)) = temp_number3
		  DO inumber=1,temp_number3
		   sudoku_logic(i_row3,xwing1_column(1),inumber) = temp_array3(inumber)
		  END DO
		END DO

		DO i_row3=1,9
                  temp_number3=0
                  temp_array3=0
                  IF (sudoku(i_row3,xwing1_column(2)) .ne. 0) CYCLE
                  IF (i_row3 .eq. i_row1) CYCLE
                  IF (i_row3 .eq. i_row2) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row3,xwing1_column(2))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row3,xwing1_column(2),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number3=temp_number3+1
                      temp_array3(temp_number3) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row3,xwing1_column(2),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row3,xwing1_column(2)) = temp_number3
                  DO inumber=1,temp_number3
                   sudoku_logic(i_row3,xwing1_column(2),inumber) = temp_array3(inumber)
                  END DO
                END DO

	     END IF

	  ! End Do over i_row2
	  END DO
	! End If over (jnumber .eq. 2)
        END IF
      ! End Do over jnumber 
      END DO
   ! End Do over i_row1
   END DO

  ! Find Simple X wing in each column
  ! Loop over each column
  DO j_column1=1,9
    temp_array1=0
    ! Loop over the rows of the column and find if only 2 squares contain a number
    DO i_row=1,9
      IF (sudoku(i_row,j_column1) .ne. 0) CYCLE
	cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
	DO inumber=1,cell_ij_numbers
	  cell_ij_logic_number=sudoku_logic(i_row,j_column1,inumber)
	  temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
	END DO
     END DO	

     !Loop over the rows again to find the 2 squares that contain that number
     DO jnumber=1,9
       temp_number1=0
       xwing1_row=0
       IF (temp_array1(jnumber) .eq. 2) THEN
	 DO i_row=1,9
	   cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
	   DO inumber=1,cell_ij_numbers
	     cell_ij_logic_number=sudoku_logic(i_row,j_column1,inumber)
	     IF (cell_ij_logic_number .eq. jnumber) THEN
	       temp_number1=temp_number1+1
	       xwing1_row(temp_number1) = i_row
	     END IF
           END DO
          END DO

	  DO j_column2=j_column1+1,9
	     temp_array2=0
	     ! Loop over the rows of the column and find if only 2 squares contain that number
	     DO i_row=1,9
	       IF (sudoku(i_row,j_column2) .ne. 0) CYCLE
		cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
		DO inumber=1,cell_ij_numbers
		  cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
		  temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
		END DO
              END DO

	      temp_number2=0
	      xwing2_row=0
	      ! Cycle over j_column2
	      IF (temp_array2(jnumber) .ne. 2) CYCLE
	      ! If we come here that means the jnumber is shared by 2 squares
	      DO i_row=1,9
		cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
		DO inumber=1,cell_ij_numbers
		  cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
		  IF (cell_ij_logic_number .eq. jnumber) THEN
		    temp_number2=temp_number2+1
		    xwing2_row(temp_number2) = i_row
		  END IF
		END DO
	      END DO

             IF ((xwing1_row(1) .eq. xwing2_row(1)) .AND. &
                 (xwing1_row(2) .eq. xwing2_row(2))) THEN
                ! We have a Simple X-wing.. Remove this number from other squares
                ! of the 2 columns
                ! Print the numbers

		DO j_column3=1,9
		  temp_number3=0
	 	  temp_array3=0
  		  IF (sudoku(xwing1_row(1),j_column3) .ne. 0) CYCLE
		  IF (j_column3 .eq. j_column1) CYCLE
		  IF (j_column3 .eq. j_column2) CYCLE
		  cell_ij_numbers=sudoku_logic_numbers(xwing1_row(1),j_column3)
		  DO inumber=1,cell_ij_numbers
		    cell_ij_logic_number=sudoku_logic(xwing1_row(1),j_column3,inumber)
		    IF (cell_ij_logic_number .eq. jnumber) CYCLe
		    temp_number3=temp_number3+1
		    temp_array3(temp_number3) = cell_ij_logic_number
		  END DO
		  ! Print out the values
		  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
		  DO inumber=1,cell_ij_numbers
		    sudoku_logic(xwing1_row(1),j_column3,inumber) = 0
		  END DO
		  sudoku_logic_numbers(xwing1_row(1),j_column3) = temp_number3
		  DO inumber=1,temp_number3
		    sudoku_logic(xwing1_row(1),j_column3,inumber) = temp_array3(inumber)
		  END DO
		END DO

                DO j_column3=1,9
                  temp_number3=0
                  temp_array3=0
                  IF (sudoku(xwing1_row(2),j_column3) .ne. 0) CYCLE
                  IF (j_column3 .eq. j_column1) CYCLE
                  IF (j_column3 .eq. j_column2) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing1_row(2),j_column3)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing1_row(2),j_column3,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLe
                    temp_number3=temp_number3+1
                    temp_array3(temp_number3) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing1_row(2),j_column3,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing1_row(2),j_column3) = temp_number3
                  DO inumber=1,temp_number3
                    sudoku_logic(xwing1_row(2),j_column3,inumber) = temp_array3(inumber)
                  END DO
                END DO

             END IF

	   ! End Do over j_column2
	   END DO
        ! End If over (jnumber .eq. 2)
        END IF
      ! End Do over jnumber
      END DO
   ! End Do over j_column1
   END DO



END SUBROUTINE Simple_XWing
!---------------------------------------------------------------------------------
! initial-11 is the input file for swordfish
!---------------------------------------------------------------------------------
SUBROUTINE Swordfish

  USE global_variables
  IMPLICIT NONE
  
  INTEGER :: i_row1,i_row2,i_row3,j_column,i,i_row6
  INTEGER :: j_column1,j_column2,j_column3,i_row,j_column6
  INTEGER,DIMENSION(9) :: temp_array1,temp_array2,temp_array3,temp_array6
  INTEGER :: temp_number1,temp_number2,temp_number3,temp_number6
  INTEGER,DIMENSION(3) :: xwing1_column,xwing2_column,xwing3_column
  INTEGER,DIMENSION(3) :: xwing1_row,xwing2_row,xwing3_row
  INTEGER,DIMENSION(9) :: swordfish_column1,swordfish_column2,swordfish_column3
  INTEGER,DIMENSION(9) :: swordfish_row1,swordfish_row2,swordfish_row3
! IMP :: This should go
  INTEGER,DIMENSION(9) :: swordfish_row,swordfish_column
  INTEGER :: inumber,jnumber,check_swordfish
  INTEGER :: cell_ij_numbers,cell_ij_logic_number
  INTEGER,DIMENSION(3) :: xwing_column_final,xwing_row_final

  !Find Swordfish in rows
  DO i_row1=1,9
!    swordfish_column=0
    temp_array1=0
    ! Loop over the columns of the row and find if 2 or 3 squares contain a number
    DO j_column=1,9
      IF (sudoku(i_row1,j_column) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
      DO inumber=1,cell_ij_numbers
	cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
	temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
     END DO

     ! Loop over the columns again to find the 2 or 3 squares that contain the number
    DO jnumber=1,9
      swordfish_column1=0
      temp_number1=0
      xwing1_column=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3)) THEN
	DO j_column=1,9
          cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
	  DO inumber=1,cell_ij_numbers
            cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
            IF (cell_ij_logic_number .eq. jnumber) THEN
	      temp_number1=temp_number1+1
	      ! The columns of i_row1 that contain the number 'jnumber'
 	      xwing1_column(temp_number1) = j_column
	    END IF
          END DO
        END DO

	DO i=1,temp_number1
	  swordfish_column1(xwing1_column(i)) = swordfish_column1(xwing1_column(i))+1
        END DO

	DO i_row2=i_row1+1,9
	  temp_array2=0
	  swordfish_column2=swordfish_column1
          ! Loop over the columns of the row and find if 2 or 3 squares that contain the number
	  DO j_column=1,9
	    IF (sudoku(i_row2,j_column) .ne. 0) CYCLE
	    cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
	    DO inumber=1,cell_ij_numbers
	      cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
	      temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
	    END DO
          END DO

	  temp_number2=0
	  xwing2_column=0
	  ! Cycle over i_row2
!	  IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
	  IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3)) THEN
	  ! If we come here that means the jnumber is shared by 2 or 3 squares
	  DO j_column=1,9
	    cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
	    DO inumber=1,cell_ij_numbers
	      cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
	      IF (cell_ij_logic_number .eq. jnumber) THEN
		temp_number2=temp_number2+1
	        xwing2_column(temp_number2) = j_column
	      END IF
	    END DO
	  END DO

	  DO i=1,temp_number2
	    swordfish_column2(xwing2_column(i)) = swordfish_column2(xwing2_column(i))+1
     	  END DO

	  ! Check if atleast one column is shared by 2 rows having jnumber
	  check_swordfish = 0
	  DO i=1,9
	     IF (swordfish_column2(i) .gt. 1) THEN
		check_swordfish = 1
		EXIT
	     END IF 
	  END DO

	  ! Cycle over i_row2 (this means i_row2 does not have any column that is 
	  ! shared with i_row1)..
	  IF (check_swordfish .eq. 0) CYCLE

	  DO i_row3=i_row2+1,9
	    temp_array3=0
	    swordfish_column3=swordfish_column2
	    ! Loop overe the columns of the row and find if 2 or 3 squares that contain the number
	    DO j_column=1,9
	      IF (sudoku(i_row3,j_column) .ne. 0) CYCLE
	      cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
	      DO inumber=1,cell_ij_numbers
	        cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
		temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
	      END DO
	    END DO

	    temp_number3=0
	    xwing3_column=0
	    ! Cycle over i_row3
!	    IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
	    IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3)) THEN
	    ! If we come here that means the jnumber is shared by 2 or 3 squares
	    DO j_column=1,9
	      cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
	      DO inumber=1,cell_ij_numbers
	        cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
	        IF (cell_ij_logic_number .eq. jnumber) THEN
		  temp_number3=temp_number3+1
		  xwing3_column(temp_number3) = j_column
		END IF
	      END DO
            END DO

	    DO i=1,temp_number3
	      swordfish_column3(xwing3_column(i)) = swordfish_column3(xwing3_column(i))+1
	    END DO

	    check_swordfish = 0
	    DO i=1,9
              IF (swordfish_column3(i) .eq. 1) THEN
                 check_swordfish=0
                 EXIT
              END IF
	      IF (swordfish_column3(i) .ge. 2) THEN
		check_swordfish = check_swordfish+1
	      END IF
	    END DO

	    ! Cycle of i_row3
	    IF (check_swordfish .ne. 3) CYCLE

	    ! If the exection comes here that means we have found a swordfish.. remove the
	    ! number from 3 columns

	    ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR SWORDFISH
	    check_swordfish=0
	    DO i=1,9
		IF (swordfish_column3(i) .ge. 2) THEN
		  check_swordfish=check_swordfish+1
		  xwing_column_final(check_swordfish) = i
		END IF
	    END DO
	    ! Write out the columns 
		

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(1)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
		  IF (i_row6 .eq. i_row3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(1))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(1),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(1),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(1)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(1),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(2)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(2))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(2),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(2),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(2)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(2),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(3)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(3))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(3),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(3),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(3)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(3),inumber) = temp_array6(inumber)
                  END DO
                END DO


	   ! End If over jnumber
	   END IF
	  ! End Do over i_row3
	  END DO
	 ! End If over jnumber
	 END  IF
	! End Do over i_row2
	END DO
      ! End If over jnumber
      END IF
    ! End Do over jnumber
    END DO
  ! End Do over i_row1
  END DO
	

  ! Find Swordfish in columns
  DO j_column1=1,9
!    swordfish_row=0
    temp_array1=0
    ! Loop over the rows of the column and find if 2 or 3 squares contain a number
    DO i_row=1,9
      IF (sudoku(i_row,j_column1) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
      DO inumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i_row,j_column1,inumber)
        temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
    END DO

    ! Loop ove the rows again to find the 2 or 3 squares that contain the number
    DO jnumber=1,9
      swordfish_row1 = 0
      temp_number1=0
      xwing1_row=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3)) THEN
         DO i_row=1,9
           cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
	   DO inumber=1,cell_ij_numbers
	     cell_ij_logic_number = sudoku_logic(i_row,j_column1,inumber)
	     IF (cell_ij_logic_number .eq. jnumber) THEN
		temp_number1=temp_number1+1
		 xwing1_row(temp_number1) = i_row
	     END IF
	   END DO
	 END DO

	DO i=1,temp_number1
	  swordfish_row1(xwing1_row(i)) = swordfish_row1(xwing1_row(i))+1
	END DO


	DO j_column2=j_column1+1,9
          temp_array2=0
	  swordfish_row2=swordfish_row1
          ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
	  DO i_row=1,9
	    IF (sudoku(i_row,j_column2) .ne. 0) CYCLE
	    cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
	    DO inumber=1,cell_ij_numbers
	       cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
	       temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
	    END DO
          END DO 


	  temp_number2=0
	  xwing2_row=0
	  ! Cycle over j_column2
!	  IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
	  IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3)) THEN
	  ! If we come here that means the jnumber is shared by 2 or 3 squares
          DO i_row=1,9
	    cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
	    DO inumber=1,cell_ij_numbers
	      cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
	      IF (cell_ij_logic_number .eq. jnumber) THEN
		temp_number2=temp_number2+1
		xwing2_row(temp_number2) = i_row
	      END IF
	    END DO
	  END DO 

	 DO i=1,temp_number2
	   swordfish_row2(xwing2_row(i)) = swordfish_row2(xwing2_row(i))+1
	 END DO


	 ! Check if atleast one row is shared by 2 columns having jnumber
	 check_swordfish = 0
	 DO i=1,9
	   IF (swordfish_row2(i) .gt. 1) THEN
	     check_swordfish = 1
	     EXIT
	   END IF
	 END DO

          ! Cycle over j_column2 (this means i_column2 does not have any column that is
          ! shared with i_column1)..
          IF (check_swordfish .eq. 0) CYCLE

	  DO j_column3=j_column2+1,9
	    temp_array3=0
	    swordfish_row3=swordfish_row2
	    ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
	    DO i_row=1,9
	      IF (sudoku(i_row,j_column3) .ne. 0) CYCLE
	      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
	      DO inumber=1,cell_ij_numbers
	        cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
		temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
	      END DO
            END DO 

	    temp_number3=0
	    xwing3_row=0
	    ! Cycle of over j_column3
!	    IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
	    IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3)) THEN
	    ! If we come here that means jnumber is shared by 2 or 3 squares
            DO i_row=1,9
	      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
	      DO inumber=1,cell_ij_numbers
		cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
		IF (cell_ij_logic_number .eq. jnumber) THEN
		  temp_number3=temp_number3+1
		  xwing3_row(temp_number3) = i_row
		END IF
	      END DO
            END DO

	    DO i=1,temp_number3
	      swordfish_row3(xwing3_row(i)) = swordfish_row3(xwing3_row(i))+1
	    END DO


	    check_swordfish=0
	    DO i=1,9
	      IF (swordfish_row3(i) .eq. 1) THEN
		 check_swordfish=0
		 EXIT
	      END IF
	      IF (swordfish_row3(i) .ge. 2) THEN
		check_swordfish=check_swordfish+1
	      END IF
	    END DO

	    ! Cycle over j_column3
	    IF (check_swordfish .ne. 3) CYCLE

            ! If the exection comes here that means we have found a swordfish.. remove the
            ! number from 3 rows 

            ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR SWORDFISH
            check_swordfish=0
            DO i=1,9
                IF (swordfish_row3(i) .ge. 2) THEN
                  check_swordfish=check_swordfish+1
                  xwing_row_final(check_swordfish) = i
                END IF
            END DO
            ! Write out the rows


                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(1),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
		  IF (j_column6 .eq. j_column3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(1),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(1),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(1),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(2),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
		  IF (j_column6 .eq. j_column3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(2),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(2),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(2),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(3),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
		  IF (j_column6 .eq. j_column3) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(3),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(3),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(3),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO


	   ! End If over jnumber
	   END IF
	  ! End Do over j_column3
	  END DO
         ! End If over jnumber
	 END IF
	! End Do over J_column2
	END DO
      ! End If over jnumber
      END IF
    ! End Do over jnumber
    END DO
  ! End Do over j_column1
  END DO



END SUBROUTINE Swordfish
!--------------------------------------------------------------------------------
! initial-12 is used for Jellyfish
!-------------------------------------------------------------------------------

SUBROUTINE Jellyfish

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row1,i_row2,i_row3,i_row4,j_column,i,i_row6
  INTEGER :: j_column1,j_column2,j_column3,j_column4,i_row,j_column6
  INTEGER,DIMENSION(9) :: temp_array1,temp_array2,temp_array3,temp_array4,temp_array6
  INTEGER :: temp_number1,temp_number2,temp_number3,temp_number4,temp_number6
  INTEGER,DIMENSION(4) :: xwing1_column,xwing2_column,xwing3_column,xwing4_column
  INTEGER,DIMENSION(4) :: xwing1_row,xwing2_row,xwing3_row,xwing4_row
  INTEGER,DIMENSION(9) :: swordfish_column1,swordfish_column2,swordfish_column3
  INTEGER,DIMENSION(9) :: swordfish_column4
  INTEGER,DIMENSION(9) :: swordfish_row1,swordfish_row2,swordfish_row3,swordfish_row4
  INTEGER :: inumber,jnumber,check_swordfish
  INTEGER :: cell_ij_numbers,cell_ij_logic_number
  INTEGER,DIMENSION(4) :: xwing_column_final,xwing_row_final

  ! Find Jellyfish in rows
  DO i_row1=1,9
!    swordfish_column=0
    temp_array1=0
    ! Loop over the columns of the row and find if 2, 3 and 4 squares contain a number
    DO j_column=1,9
      IF (sudoku(i_row1,j_column) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
      DO inumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
        temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
     END DO

     ! Loop over the columns again to find the 2, 3 or 4 squares that contain the number
    DO jnumber=1,9
      swordfish_column1=0
      temp_number1=0
      xwing1_column=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3) .OR. &
						(temp_array1(jnumber) .eq. 4)) THEN
        DO j_column=1,9
          cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
          DO inumber=1,cell_ij_numbers
            cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
            IF (cell_ij_logic_number .eq. jnumber) THEN
              temp_number1=temp_number1+1
              ! The columns of i_row1 that contain the number 'jnumber'
              xwing1_column(temp_number1) = j_column
            END IF
          END DO
        END DO

        DO i=1,temp_number1
          swordfish_column1(xwing1_column(i)) = swordfish_column1(xwing1_column(i))+1
        END DO

        DO i_row2=i_row1+1,9
          temp_array2=0
          swordfish_column2=swordfish_column1
          ! Loop over the columns of the row and find if 2, 3 or 4 squares that contain the number
          DO j_column=1,9
            IF (sudoku(i_row2,j_column) .ne. 0) CYCLE
            cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
              temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
            END DO
          END DO

          temp_number2=0
          xwing2_column=0
          ! Cycle over i_row2
!         IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
          IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3) .OR. &
						(temp_array2(jnumber) .eq. 4)) THEN
          ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
          DO j_column=1,9
            cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
              IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number2=temp_number2+1
                xwing2_column(temp_number2) = j_column
              END IF
            END DO
          END DO

          DO i=1,temp_number2
            swordfish_column2(xwing2_column(i)) = swordfish_column2(xwing2_column(i))+1
          END DO

          ! Check if atleast one column is shared by 2 rows having jnumber
!          check_swordfish = 0
!          DO i=1,9
!             IF (swordfish_column2(i) .gt. 1) THEN
!                check_swordfish = 1
!                EXIT
!             END IF
!          END DO

          ! Cycle over i_row2 (this means i_row2 does not have any column that is
          ! shared with i_row1)..
!          IF (check_swordfish .eq. 0) CYCLE

          DO i_row3=i_row2+1,9
            temp_array3=0
            swordfish_column3=swordfish_column2
            ! Loop overe the columns of the row and find if 2,3 or 4 squares that contain the number
            DO j_column=1,9
              IF (sudoku(i_row3,j_column) .ne. 0) CYCLE
              cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
                temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
              END DO
            END DO

            temp_number3=0
            xwing3_column=0
            ! Cycle over i_row3
!           IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
            IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3) .OR. &
						(temp_array3(jnumber) .eq. 4)) THEN
            ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
            DO j_column=1,9
              cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
                IF (cell_ij_logic_number .eq. jnumber) THEN
                  temp_number3=temp_number3+1
                  xwing3_column(temp_number3) = j_column
                END IF
              END DO
            END DO

            DO i=1,temp_number3
              swordfish_column3(xwing3_column(i)) = swordfish_column3(xwing3_column(i))+1
            END DO

          ! Check if atleast one column is shared by 2 rows having jnumber
!          check_swordfish = 0
!          DO i=1,9
!             IF (swordfish_column3(i) .gt. 1) THEN
!                check_swordfish = check_swordfish+1
!             END IF
!          END DO

          ! Cycle over i_row2 (this means i_row2 does not have any column that is
          ! shared with i_row1)..
!          IF (check_swordfish .eq. 0) CYCLE

	  DO i_row4=i_row3+1,9
	    temp_array4=0
	    swordfish_column4=swordfish_column3
	    ! Loop over the columns of the row and find if 2, 3 or 4 squares that contain number
	    DO j_column=1,9
	      IF (sudoku(i_row4,j_column) .ne. 0) CYCLE
	      cell_ij_numbers=sudoku_logic_numbers(i_row4,j_column)
	      DO inumber=1,cell_ij_numbers
	        cell_ij_logic_number=sudoku_logic(i_row4,j_column,inumber)
	        temp_array4(cell_ij_logic_number) = temp_array4(cell_ij_logic_number)+1
	      END DO
             END DO 

	     temp_number4=0
	     xwing4_column=0
             IF ((temp_array4(jnumber) .eq. 2) .OR. (temp_array4(jnumber) .eq. 3) .OR. &
                                                (temp_array4(jnumber) .eq. 4)) THEN
		! If we come here that means the jnumber is shared by 2, 3 or 4 squares
	        DO j_column=1,9
		  cell_ij_numbers=sudoku_logic_numbers(i_row4,j_column)
		  DO inumber=1,cell_ij_numbers
		    cell_ij_logic_number=sudoku_logic(i_row4,j_column,inumber)
		    IF (cell_ij_logic_number .eq. jnumber) THEN
		      temp_number4=temp_number4+1
		      xwing4_column(temp_number4) = j_column
		    END IF
		  END DO
	        END DO

		DO i=1,temp_number4
		  swordfish_column4(xwing4_column(i)) = swordfish_column4(xwing4_column(i))+1
		END DO

            check_swordfish = 0
            DO i=1,9
              IF (swordfish_column4(i) .eq. 1) THEN
                 check_swordfish=0
                 EXIT
              END IF
              IF (swordfish_column4(i) .ge. 2) THEN
                check_swordfish = check_swordfish+1
              END IF
            END DO

            ! Cycle of i_row4
            IF (check_swordfish .ne. 4) CYCLE

            ! If the exection comes here that means we have found a JELLYFISH.. remove the
            ! number from 4 columns

            ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR JELLYFISH
            check_swordfish=0
            DO i=1,9
                IF (swordfish_column4(i) .ge. 2) THEN
                  check_swordfish=check_swordfish+1
                  xwing_column_final(check_swordfish) = i
                END IF
            END DO
            ! Write out the columns


                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(1)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
		  IF (i_row6 .eq. i_row4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(1))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(1),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(1),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(1)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(1),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(2)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(2))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(2),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(2),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(2)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(2),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(3)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(3))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(3),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(3),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(3)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(3),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(4)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(4))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(4),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(4),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(4)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(4),inumber) = temp_array6(inumber)
                  END DO
                END DO


	  ! End If over jnumber
	  END IF
	 ! End Do over i_row4
 	 END DO
	! End If over jnumber
	END IF
       ! End Do over i_row3
       END DO
      ! End If over jnumber
      END IF
     ! End Do over i_row2
     END DO
    ! End If over jnumber
    END IF
   ! End Do over jnumber
   END DO
  ! End Do over i_row1
  END DO


  ! Find Jellyfish in columns
  DO j_column1=1,9
!    swordfish_row=0
    temp_array1=0
    ! Loop over the rows of the column and find if 2 or 3 squares contain a number
    DO i_row=1,9
      IF (sudoku(i_row,j_column1) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
      DO inumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i_row,j_column1,inumber)
        temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
    END DO

    ! Loop ove the rows again to find the 2 or 3 squares that contain the number
    DO jnumber=1,9
      swordfish_row1 = 0
      temp_number1=0
      xwing1_row=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3) .OR. &
					(temp_array1(jnumber) .eq. 4)) THEN
         DO i_row=1,9
           cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
           DO inumber=1,cell_ij_numbers
             cell_ij_logic_number = sudoku_logic(i_row,j_column1,inumber)
             IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number1=temp_number1+1
                 xwing1_row(temp_number1) = i_row
             END IF
           END DO
         END DO

        DO i=1,temp_number1
          swordfish_row1(xwing1_row(i)) = swordfish_row1(xwing1_row(i))+1
        END DO

        DO j_column2=j_column1+1,9
          temp_array2=0
          swordfish_row2=swordfish_row1
          ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
          DO i_row=1,9
            IF (sudoku(i_row,j_column2) .ne. 0) CYCLE
            cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
            DO inumber=1,cell_ij_numbers
               cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
               temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
            END DO
          END DO

          temp_number2=0
          xwing2_row=0
          ! Cycle over j_column2
!         IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
          IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3) .OR. &
						(temp_array2(jnumber) .eq. 4)) THEN
          ! If we come here that means the jnumber is shared by 2 or 3 squares
          DO i_row=1,9
            cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
              IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number2=temp_number2+1
                xwing2_row(temp_number2) = i_row
              END IF
            END DO
          END DO

         DO i=1,temp_number2
           swordfish_row2(xwing2_row(i)) = swordfish_row2(xwing2_row(i))+1
         END DO

          DO j_column3=j_column2+1,9
            temp_array3=0
            swordfish_row3=swordfish_row2
            ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
            DO i_row=1,9
              IF (sudoku(i_row,j_column3) .ne. 0) CYCLE
              cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
                temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
              END DO
            END DO

            temp_number3=0
            xwing3_row=0
            ! Cycle of over j_column3
!           IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
            IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3) .OR. &
						(temp_array3(jnumber) .eq. 4)) THEN
            ! If we come here that means jnumber is shared by 2 or 3 squares
            DO i_row=1,9
              cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
                IF (cell_ij_logic_number .eq. jnumber) THEN
                  temp_number3=temp_number3+1
                  xwing3_row(temp_number3) = i_row
                END IF
              END DO
            END DO

            DO i=1,temp_number3
              swordfish_row3(xwing3_row(i)) = swordfish_row3(xwing3_row(i))+1
            END DO

	    DO j_column4=j_column3+1,9
	      temp_array4=0
	      swordfish_row4=swordfish_row3
! Loop over the rows of the column and find if 2 or 3 squares that contain the number
	      DO i_row=1,9
		IF (sudoku(i_row,j_column4) .ne. 0) CYCLE
	        cell_ij_numbers=sudoku_logic_numbers(i_row,j_column4)
	        DO inumber=1,cell_ij_numbers
		  cell_ij_logic_number=sudoku_logic(i_row,j_column4,inumber)
	          temp_array4(cell_ij_logic_number) = temp_array4(cell_ij_logic_number)+1
		END DO
	      END DO

	      temp_number4=0
	      xwing4_row=0
            IF ((temp_array4(jnumber) .eq. 2) .OR. (temp_array4(jnumber) .eq. 3) .OR. &
                                                (temp_array4(jnumber) .eq. 4)) THEN
            ! If we come here that means jnumber is shared by 2 or 3 squares
	    DO i_row=1,9
	      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column4)
	      DO inumber=1,cell_ij_numbers
	        cell_ij_logic_number=sudoku_logic(i_row,j_column4,inumber)
		IF (cell_ij_logic_number .eq. jnumber) THEN
		  temp_number4=temp_number4+1
		  xwing4_row(temp_number4) = i_row
		END IF
	      END DO
	    END DO

	    DO i=1,temp_number4
	      swordfish_row4(xwing4_row(i)) = swordfish_row4(xwing4_row(i))+1
	    END DO

	    check_swordfish = 0
	    DO i=1,9
	      IF (swordfish_row4(i) .eq. 1) THEN
		check_swordfish = 0
		EXIT
	      END IF
	      IF (swordfish_row4(i) .ge. 2) THEN
		check_swordfish = check_swordfish+1
	      END IF
	    END DO

	    ! Cycle over j_column4
	    IF (check_swordfish .ne. 4) CYCLE

            ! If the exection comes here that means we have found a Jellyfish.. remove the
            ! number from 4 rows

            ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR JELLYFISH
            check_swordfish=0
            DO i=1,9
                IF (swordfish_row4(i) .ge. 2) THEN
                  check_swordfish=check_swordfish+1
                  xwing_row_final(check_swordfish) = i
                END IF
            END DO
            ! Write out the rows

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(1),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
		  IF (j_column6 .eq. j_column4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(1),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(1),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(1),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(2),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(2),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(2),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(2),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(3),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(3),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(3),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(3),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(4),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(4),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(4),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(4),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(4),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(4),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO


          ! End If over jnumber
          END IF
         ! End Do over j_column4
         END DO
        ! End If over jnumber
        END IF
       ! End Do over j_column3
       END DO
      ! End If over jnumber
      END IF
     ! End Do over j_column2
     END DO
    ! End If over jnumber
    END IF
   ! End Do over jnumber
   END DO
  ! End Do over j_column1
  END DO



END SUBROUTINE Jellyfish
!-----------------------------------------------------------------------------------
! initial-13 is the initial file for Squirmbag
!-----------------------------------------------------------------------------------

SUBROUTINE Squirmbag

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row1,i_row2,i_row3,i_row4,i_row5,j_column,i
  INTEGER :: j_column1,j_column2,j_column3,j_column4,j_column5,i_row
  INTEGER,DIMENSION(9) :: temp_array1,temp_array2,temp_array3,temp_array4,temp_array5
  INTEGER :: temp_number1,temp_number2,temp_number3,temp_number4,temp_number5
  INTEGER,DIMENSION(5) :: xwing1_column,xwing2_column,xwing3_column,xwing4_column
  INTEGER,DIMENSION(5) :: xwing5_column
  INTEGER,DIMENSION(5) :: xwing1_row,xwing2_row,xwing3_row,xwing4_row,xwing5_row
  INTEGER,DIMENSION(9) :: swordfish_column1,swordfish_column2,swordfish_column3
  INTEGER,DIMENSION(9) :: swordfish_column4,swordfish_column5
  INTEGER,DIMENSION(9) :: swordfish_row1,swordfish_row2,swordfish_row3,swordfish_row4
  INTEGER,DIMENSION(9) :: swordfish_row5
  INTEGER :: inumber,jnumber,check_swordfish
  INTEGER :: cell_ij_numbers,cell_ij_logic_number
  INTEGER,DIMENSION(5) :: xwing_column_final,xwing_row_final
  INTEGER :: temp_number6,i_row6,j_column6
  INTEGER,DIMENSION(9) :: temp_array6

  ! Find Squirmbag in rows
  DO i_row1=1,9
!    swordfish_column=0
    temp_array1=0
    ! Loop over the columns of the row and find if 2, 3 and 4 squares contain a number
    DO j_column=1,9
      IF (sudoku(i_row1,j_column) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
      DO inumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
        temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
     END DO

     ! Loop over the columns again to find the 2, 3 or 4 squares that contain the number
    DO jnumber=1,9
      swordfish_column1=0
      temp_number1=0
      xwing1_column=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3) .OR. &
            (temp_array1(jnumber) .eq. 4) .OR. (temp_array1(jnumber) .eq. 5)) THEN
        DO j_column=1,9
          cell_ij_numbers=sudoku_logic_numbers(i_row1,j_column)
          DO inumber=1,cell_ij_numbers
            cell_ij_logic_number=sudoku_logic(i_row1,j_column,inumber)
            IF (cell_ij_logic_number .eq. jnumber) THEN
              temp_number1=temp_number1+1
              ! The columns of i_row1 that contain the number 'jnumber'
              xwing1_column(temp_number1) = j_column
            END IF
          END DO
        END DO

        DO i=1,temp_number1
          swordfish_column1(xwing1_column(i)) = swordfish_column1(xwing1_column(i))+1
        END DO

        DO i_row2=i_row1+1,9
          temp_array2=0
          swordfish_column2=swordfish_column1
          ! Loop over the columns of the row and find if 2, 3 or 4 squares that contain the number
          DO j_column=1,9
            IF (sudoku(i_row2,j_column) .ne. 0) CYCLE
            cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
              temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
            END DO
          END DO

          temp_number2=0
          xwing2_column=0
          ! Cycle over i_row2
!         IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
          IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3) .OR. &
                    (temp_array2(jnumber) .eq. 4) .OR. (temp_array2(jnumber) .eq. 5)) THEN
          ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
          DO j_column=1,9
            cell_ij_numbers=sudoku_logic_numbers(i_row2,j_column)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row2,j_column,inumber)
              IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number2=temp_number2+1
                xwing2_column(temp_number2) = j_column
              END IF
            END DO
          END DO

          DO i=1,temp_number2
            swordfish_column2(xwing2_column(i)) = swordfish_column2(xwing2_column(i))+1
          END DO

          DO i_row3=i_row2+1,9
            temp_array3=0
            swordfish_column3=swordfish_column2
            ! Loop overe the columns of the row and find if 2,3 or 4 squares that contain the number
            DO j_column=1,9
              IF (sudoku(i_row3,j_column) .ne. 0) CYCLE
              cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
                temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
              END DO
            END DO

            temp_number3=0
            xwing3_column=0
            ! Cycle over i_row3
!           IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
            IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3) .OR. &
                         (temp_array3(jnumber) .eq. 4) .OR. (temp_array3(jnumber) .eq. 5)) THEN
            ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
            DO j_column=1,9
              cell_ij_numbers=sudoku_logic_numbers(i_row3,j_column)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row3,j_column,inumber)
                IF (cell_ij_logic_number .eq. jnumber) THEN
                  temp_number3=temp_number3+1
                  xwing3_column(temp_number3) = j_column
                END IF
              END DO
            END DO

            DO i=1,temp_number3
              swordfish_column3(xwing3_column(i)) = swordfish_column3(xwing3_column(i))+1
            END DO

          DO i_row4=i_row3+1,9
            temp_array4=0
            swordfish_column4=swordfish_column3
            ! Loop over the columns of the row and find if 2, 3 or 4 squares that contain number
            DO j_column=1,9
              IF (sudoku(i_row4,j_column) .ne. 0) CYCLE
              cell_ij_numbers=sudoku_logic_numbers(i_row4,j_column)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row4,j_column,inumber)
                temp_array4(cell_ij_logic_number) = temp_array4(cell_ij_logic_number)+1
              END DO
             END DO

             temp_number4=0
             xwing4_column=0
             IF ((temp_array4(jnumber) .eq. 2) .OR. (temp_array4(jnumber) .eq. 3) .OR. &
                        (temp_array4(jnumber) .eq. 4) .OR. (temp_array4(jnumber) .eq. 5)) THEN
                ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
                DO j_column=1,9
                  cell_ij_numbers=sudoku_logic_numbers(i_row4,j_column)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row4,j_column,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) THEN
                      temp_number4=temp_number4+1
                      xwing4_column(temp_number4) = j_column
                    END IF
                  END DO
                END DO

                DO i=1,temp_number4
                  swordfish_column4(xwing4_column(i)) = swordfish_column4(xwing4_column(i))+1
                END DO

		DO i_row5=i_row4+1,9
		  temp_array5=0
	 	  swordfish_column5=swordfish_column4
		  ! Loop over the columns of the row (2,3,4,5 squares that contain jnumber)
		  DO j_column=1,9
		    IF (sudoku(i_row5,j_column) .ne. 0) CYCLE
		    cell_ij_numbers=sudoku_logic_numbers(i_row5,j_column)
		    DO inumber=1,cell_ij_numbers
		      cell_ij_logic_number=sudoku_logic(i_row5,j_column,inumber)
		      temp_array5(cell_ij_logic_number) = temp_array5(cell_ij_logic_number)+1
		    END DO
		  END DO

		  temp_number5=0
		  xwing5_column=0
             IF ((temp_array5(jnumber) .eq. 2) .OR. (temp_array5(jnumber) .eq. 3) .OR. &
                        (temp_array5(jnumber) .eq. 4) .OR. (temp_array5(jnumber) .eq. 5)) THEN
                ! If we come here that means the jnumber is shared by 2, 3 or 4 squares
		  DO j_column=1,9
		    cell_ij_numbers=sudoku_logic_numbers(i_row5,j_column)
		    DO inumber=1,cell_ij_numbers
		      cell_ij_logic_number=sudoku_logic(i_row5,j_column,inumber)
		      IF (cell_ij_logic_number .eq. jnumber) THEN
			temp_number5=temp_number5+1
			xwing5_column(temp_number5) = j_column
		      END IF
		    END DO
		  END DO 

                DO i=1,temp_number5
                  swordfish_column5(xwing5_column(i)) = swordfish_column5(xwing5_column(i))+1
                END DO

            check_swordfish = 0
            DO i=1,9
              IF (swordfish_column5(i) .eq. 1) THEN
                 check_swordfish=0
                 EXIT
              END IF
              IF (swordfish_column5(i) .ge. 2) THEN
                check_swordfish = check_swordfish+1
              END IF
            END DO

            ! Cycle of i_row5
            IF (check_swordfish .ne. 5) CYCLE

            ! If the exection comes here that means we have found a swordfish.. remove the
            ! number from 3 columns

           ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR JELLYFISH
            check_swordfish=0
            DO i=1,9
                IF (swordfish_column5(i) .ge. 2) THEN
                  check_swordfish=check_swordfish+1
                  xwing_column_final(check_swordfish) = i
                END IF
            END DO
            ! Write out the columns

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(1)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
		  IF (i_row6 .eq. i_row5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(1))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(1),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(1),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(1)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(1),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(2)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  IF (i_row6 .eq. i_row5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(2))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(2),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(2),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(2)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(2),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(3)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  IF (i_row6 .eq. i_row5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(3))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(3),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(3),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(3)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(3),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(4)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  IF (i_row6 .eq. i_row5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(4))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(4),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(4),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(4)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(4),inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO i_row6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(i_row6,xwing_column_final(5)) .ne. 0) CYCLE
                  IF (i_row6 .eq. i_row1) CYCLE
                  IF (i_row6 .eq. i_row2) CYCLE
                  IF (i_row6 .eq. i_row3) CYCLE
                  IF (i_row6 .eq. i_row4) CYCLE
                  IF (i_row6 .eq. i_row5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(i_row6,xwing_column_final(5))
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(i_row6,xwing_column_final(5),inumber)
                      IF (cell_ij_logic_number .eq. jnumber) CYCLE
                      temp_number6=temp_number6+1
                      temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! print out the values
                  ! Update the sudoku_logic_numbers and sudoku_logic_array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(i_row6,xwing_column_final(5),inumber)=0
                  END DO
                  sudoku_logic_numbers(i_row6,xwing_column_final(5)) = temp_number6
                  DO inumber=1,temp_number6
                   sudoku_logic(i_row6,xwing_column_final(5),inumber) = temp_array6(inumber)
                  END DO
                END DO

	    ! End If over jnumber
	    END IF
	   ! End Do over i_row5
	   END DO
          ! End If over jnumber
          END IF
         ! End Do over i_row4
         END DO
        ! End If over jnumber
        END IF
       ! End Do over i_row3
       END DO
      ! End If over jnumber
      END IF
     ! End Do over i_row2
     END DO
    ! End If over jnumber
    END IF
   ! End Do over jnumber
   END DO
  ! End Do over i_row1
  END DO

  
  ! Find Squirmbag in columns
  DO j_column1=1,9
!    swordfish_row=0
    temp_array1=0
    ! Loop over the rows of the column and find if 2 or 3 squares contain a number
    DO i_row=1,9
      IF (sudoku(i_row,j_column1) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
      DO inumber=1,cell_ij_numbers
        cell_ij_logic_number=sudoku_logic(i_row,j_column1,inumber)
        temp_array1(cell_ij_logic_number) = temp_array1(cell_ij_logic_number)+1
      END DO
    END DO

    ! Loop ove the rows again to find the 2 or 3 squares that contain the number
    DO jnumber=1,9
      swordfish_row1 = 0
      temp_number1=0
      xwing1_row=0
      IF ((temp_array1(jnumber) .eq. 2) .OR. (temp_array1(jnumber) .eq. 3) .OR. &
                  (temp_array1(jnumber) .eq. 4) .OR. (temp_array1(jnumber) .eq. 5)) THEN
         DO i_row=1,9
           cell_ij_numbers=sudoku_logic_numbers(i_row,j_column1)
           DO inumber=1,cell_ij_numbers
             cell_ij_logic_number = sudoku_logic(i_row,j_column1,inumber)
             IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number1=temp_number1+1
                 xwing1_row(temp_number1) = i_row
             END IF
           END DO
         END DO

        DO i=1,temp_number1
          swordfish_row1(xwing1_row(i)) = swordfish_row1(xwing1_row(i))+1
        END DO

        DO j_column2=j_column1+1,9
          temp_array2=0
          swordfish_row2=swordfish_row1
          ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
          DO i_row=1,9
            IF (sudoku(i_row,j_column2) .ne. 0) CYCLE
            cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
            DO inumber=1,cell_ij_numbers
               cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
               temp_array2(cell_ij_logic_number) = temp_array2(cell_ij_logic_number)+1
            END DO
          END DO

          temp_number2=0
          xwing2_row=0
          ! Cycle over j_column2
!         IF ((temp_array2(jnumber) .ne. 2) .OR. (temp_array2(jnumber) .ne. 3)) CYCLE
          IF ((temp_array2(jnumber) .eq. 2) .OR. (temp_array2(jnumber) .eq. 3) .OR. &
                          (temp_array2(jnumber) .eq. 4) .OR. (temp_array2(jnumber) .eq. 5)) THEN
          ! If we come here that means the jnumber is shared by 2 or 3 squares
          DO i_row=1,9
            cell_ij_numbers=sudoku_logic_numbers(i_row,j_column2)
            DO inumber=1,cell_ij_numbers
              cell_ij_logic_number=sudoku_logic(i_row,j_column2,inumber)
              IF (cell_ij_logic_number .eq. jnumber) THEN
                temp_number2=temp_number2+1
                xwing2_row(temp_number2) = i_row
              END IF
            END DO
          END DO

         DO i=1,temp_number2
           swordfish_row2(xwing2_row(i)) = swordfish_row2(xwing2_row(i))+1
         END DO

          DO j_column3=j_column2+1,9
            temp_array3=0
            swordfish_row3=swordfish_row2
            ! Loop over the rows of the column and find if 2 or 3 squares that contain the number
            DO i_row=1,9
              IF (sudoku(i_row,j_column3) .ne. 0) CYCLE
              cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
                temp_array3(cell_ij_logic_number) = temp_array3(cell_ij_logic_number)+1
              END DO
            END DO

            temp_number3=0
            xwing3_row=0
            ! Cycle of over j_column3
!           IF ((temp_array3(jnumber) .ne. 2) .OR. (temp_array3(jnumber) .ne. 3)) CYCLE
            IF ((temp_array3(jnumber) .eq. 2) .OR. (temp_array3(jnumber) .eq. 3) .OR. &
                            (temp_array3(jnumber) .eq. 4) .OR. (temp_array3(jnumber) .eq. 5)) THEN
            ! If we come here that means jnumber is shared by 2 or 3 squares
            DO i_row=1,9
              cell_ij_numbers=sudoku_logic_numbers(i_row,j_column3)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row,j_column3,inumber)
                IF (cell_ij_logic_number .eq. jnumber) THEN
                  temp_number3=temp_number3+1
                  xwing3_row(temp_number3) = i_row
                END IF
              END DO
            END DO

            DO i=1,temp_number3
              swordfish_row3(xwing3_row(i)) = swordfish_row3(xwing3_row(i))+1
            END DO

            DO j_column4=j_column3+1,9
              temp_array4=0
              swordfish_row4=swordfish_row3
! Loop over the rows of the column and find if 2 or 3 squares that contain the number
              DO i_row=1,9
                IF (sudoku(i_row,j_column4) .ne. 0) CYCLE
                cell_ij_numbers=sudoku_logic_numbers(i_row,j_column4)
                DO inumber=1,cell_ij_numbers
                  cell_ij_logic_number=sudoku_logic(i_row,j_column4,inumber)
                  temp_array4(cell_ij_logic_number) = temp_array4(cell_ij_logic_number)+1
                END DO
              END DO

              temp_number4=0
              xwing4_row=0
            IF ((temp_array4(jnumber) .eq. 2) .OR. (temp_array4(jnumber) .eq. 3) .OR. &
                         (temp_array4(jnumber) .eq. 4) .OR. (temp_array4(jnumber) .eq. 5)) THEN
            ! If we come here that means jnumber is shared by 2 or 3 squares
            DO i_row=1,9
              cell_ij_numbers=sudoku_logic_numbers(i_row,j_column4)
              DO inumber=1,cell_ij_numbers
                cell_ij_logic_number=sudoku_logic(i_row,j_column4,inumber)
                IF (cell_ij_logic_number .eq. jnumber) THEN
                  temp_number4=temp_number4+1
                  xwing4_row(temp_number4) = i_row
                END IF
              END DO
            END DO

            DO i=1,temp_number4
              swordfish_row4(xwing4_row(i)) = swordfish_row4(xwing4_row(i))+1
            END DO

	    DO j_column5=j_column4+1,9
	      temp_array5=0
	      swordfish_row5=swordfish_row4
! Loop over the rows of the column and find if 2 or 3 squares that contain the number
	      DO i_row=1,9
		IF (sudoku(i_row,j_column5) .ne. 0) CYCLE
		cell_ij_numbers=sudoku_logic_numbers(i_row,j_column5)
		DO inumber=1,cell_ij_numbers
		  cell_ij_logic_number=sudoku_logic(i_row,j_column5,inumber)
		  temp_array5(cell_ij_logic_number) = temp_array5(cell_ij_logic_number)+1
		END DO
	      END DO

	      temp_number5=0
	      xwing5_row=0
            IF ((temp_array5(jnumber) .eq. 2) .OR. (temp_array5(jnumber) .eq. 3) .OR. &
                         (temp_array5(jnumber) .eq. 4) .OR. (temp_array5(jnumber) .eq. 5)) THEN
            ! If we come here that means jnumber is shared by 2 or 3 squares
	    DO i_row=1,9
	      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column5)
	      DO inumber=1,cell_ij_numbers
		cell_ij_logic_number=sudoku_logic(i_row,j_column5,inumber)
		IF (cell_ij_logic_number .eq. jnumber) THEN
		  temp_number5=temp_number5+1
		  xwing5_row(temp_number5) = i_row
		END IF
	      END DO
	    END DO

            DO i=1,temp_number5
              swordfish_row5(xwing5_row(i)) = swordfish_row5(xwing5_row(i))+1
            END DO

            check_swordfish = 0
            DO i=1,9
              IF (swordfish_row5(i) .eq. 1) THEN
                 check_swordfish=0
                 EXIT
              END IF
              IF (swordfish_row5(i) .ge. 2) THEN
                check_swordfish = check_swordfish+1
              END IF
            END DO


            ! Cycle of j_column5
            IF (check_swordfish .ne. 5) CYCLE

            ! If the exection comes here that means we have found a Jellyfish.. remove the
            ! number from 3 rows

           ! NEWLY ADDED TO STORE ROWS AND COLUMNS FOR JELLYFISH
            check_swordfish=0
            DO i=1,9
                IF (swordfish_row5(i) .ge. 2) THEN
                  check_swordfish=check_swordfish+1
                  xwing_row_final(check_swordfish) = i
                END IF
            END DO
            ! Write out the rows

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(1),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
		  IF (j_column6 .eq. j_column5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(1),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(1),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(1),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(1),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(2),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  IF (j_column6 .eq. j_column5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(2),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(2),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(2),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(2),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(3),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  IF (j_column6 .eq. j_column5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(3),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(3),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(3),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(3),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(4),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  IF (j_column6 .eq. j_column5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(4),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(4),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(4),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(4),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(4),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

                DO j_column6=1,9
                  temp_number6=0
                  temp_array6=0
                  IF (sudoku(xwing_row_final(5),j_column6) .ne. 0) CYCLE
                  IF (j_column6 .eq. j_column1) CYCLE
                  IF (j_column6 .eq. j_column2) CYCLE
                  IF (j_column6 .eq. j_column3) CYCLE
                  IF (j_column6 .eq. j_column4) CYCLE
                  IF (j_column6 .eq. j_column5) CYCLE
                  cell_ij_numbers=sudoku_logic_numbers(xwing_row_final(5),j_column6)
                  DO inumber=1,cell_ij_numbers
                    cell_ij_logic_number=sudoku_logic(xwing_row_final(5),j_column6,inumber)
                    IF (cell_ij_logic_number .eq. jnumber) CYCLE
                    temp_number6=temp_number6+1
                    temp_array6(temp_number6) = cell_ij_logic_number
                  END DO
                  ! Print out the values
                  ! Update the sudoku_logic_nuimebrs and sudoku_logic array
                  DO inumber=1,cell_ij_numbers
                    sudoku_logic(xwing_row_final(5),j_column6,inumber) = 0
                  END DO
                  sudoku_logic_numbers(xwing_row_final(5),j_column6) = temp_number6
                  DO inumber=1,temp_number6
                    sudoku_logic(xwing_row_final(5),j_column6,inumber) = temp_array6(inumber)
                  END DO
                END DO

            ! End If over jnumber
            END IF
           ! End Do over j_column5
           END DO
          ! End If over jnumber
          END IF
         ! End Do over j_column4
         END DO
        ! End If over jnumber
        END IF
       ! End Do over j_column3
       END DO
      ! End If over jnumber
      END IF
     ! End Do over j_column2
     END DO
    ! End If over jnumber
    END IF
   ! End Do over jnumber
   END DO
  ! End Do over j_column1
  END DO


END SUBROUTINE Squirmbag
!--------------------------------------------------------------------------------
