!--------------------------------------------------------------------------
! initial-29 and initial-30 are used to test simple_forcing_loops subroutine
!------------------------------------------------------------------------

SUBROUTINE simple_forcing_loops

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,small_cell_row,small_cell_column,m
  INTEGER,DIMENSION(2) :: cell_value
  INTEGER :: cell_ij_numbers


  ! For each square
  DO i_row = 1,9
    DO j_column = 1,9
!  DO i_row = 4,4
!    DO j_column = 6,6

      IF (sudoku(i_row,j_column) .ne. 0) CYCLE
      forcing_loop_stack_row = 0
      forcing_loop_stack_column = 0
      forcing_loop_stack_length = 0
      forcing_loop_row=0
      forcing_loop_column=0
      forcing_loop_block=0
      forcing_loop_stack_value=0
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column)

      IF (cell_ij_numbers .ne. 2) CYCLE
      cell_value(1) = sudoku_logic(i_row,j_column,1)
      cell_value(2) = sudoku_logic(i_row,j_column,2)

      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      forcing_loop_initial_value = cell_value(2)
      CALL find_forcing_loops(i_row,j_column,cell_value(1))
!      CALL find_forcing_loops(5,3,2)
!      STOP

! IMP: we do not need to do call find_forcing_loops for cell_value(2) as the
! simple forcing loop is bidirectional.. again since we are calling find_forcing_loops
! for all the buddies of the initial square (row, column and block) we do not need
! to call again for cell_value(2)

   END DO
 END DO


END SUBROUTINE simple_forcing_loops

!-----------------------------------------------------------------------------

RECURSIVE SUBROUTINE find_forcing_loops(i_row,j_column,forcing_loop_value)	

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,forcing_loop_value
  INTEGER :: small_cell_row,small_cell_column,m,k
  INTEGER :: check_loop
  INTEGER,DIMENSION(2) :: cell_value
  INTEGER :: cell_k_numbers,check,ii,istack
  INTEGER :: check_loop_row,check_loop_block,check_loop_column
  INTEGER :: iblock_row,iblock_column,check_block
  INTEGER :: ii_other,jj_other
  INTEGER :: ii_other1,jj_other1
  INTEGER,DIMENSION(25) :: buddies_row_X,buddies_row_Y,buddies_row_XY
  INTEGER,DIMENSION(25) :: buddies_column_X,buddies_column_Y,buddies_column_XY
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: temp_number,inumber,knumber
  INTEGER :: buddy,buddy_xy,column_buddy_xy,row_buddy_xy
  INTEGER :: column_x_buddy,column_y_buddy,ibuddy,row_x_buddy,row_y_buddy
  INTEGER :: cell_ij_logic_number,j,i,jbuddy
  INTEGER :: ii_other2,jj_other2
  INTEGER :: row1,column1,row2,column2
  INTEGER :: Z_value,cell_ij_numbers


      IF (forcing_loop_stack_length .gt. 1) THEN
	DO istack=1,forcing_loop_stack_length-1
	  IF ((i_row .eq. forcing_loop_stack_row(istack)) .AND. &
		(j_column .eq. forcing_loop_stack_column(istack))) THEN
		RETURN
	  END IF
        END DO	
      END IF

! Loop over the row
kloop1:  DO k=1,9
    IF (sudoku(i_row,k) .ne. 0) CYCLE
    IF (k .eq. j_column) CYCLE

        DO istack=2,forcing_loop_stack_length
          IF ((i_row .eq. forcing_loop_stack_row(istack)) .AND. &
                (k .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop1
          END IF
        END DO 


    cell_k_numbers=sudoku_logic_numbers(i_row,k)
    IF (cell_k_numbers .ne. 2) CYCLE
! make sure the new square is not one of the existing square in the stack
! if the square is the initial square then the stack should have atleast
! 3 intermediate squares.. 
! Also it must span atleast 2 rows, 2 columns and 2 blocks
    cell_value(1) = sudoku_logic(i_row,k,1)
    cell_value(2) = sudoku_logic(i_row,k,2)

    check = 0
    check_loop_row =0
    check_loop_column =0
    check_loop_block =0
    DO ii=1,9
	IF (forcing_loop_row(ii) .ge. 2) THEN
	   check_loop_row = check_loop_row+1
        END IF
    END DO
    DO ii=1,9
	IF (forcing_loop_column(ii) .ge. 2) THEN
	    check_loop_column=check_loop_column+1
	END IF
    END DO
    DO ii=1,9
	IF (forcing_loop_block(ii) .ge. 1) THEN
	   check_loop_block=check_loop_block+1
	END IF
    END DO

    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
		(check_loop_block .ge. 2)) THEN
	   check=1
    END IF

    IF ((i_row .eq. forcing_loop_stack_row(1)) .AND. (k .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN

!---------------------------------------------------------------------------------------
! Remove the number from the buddies of two adjacent squares
       DO istack=1,forcing_loop_stack_length
	  IF (istack .ne. forcing_loop_stack_length) THEN
	    row1=forcing_loop_stack_row(istack)
	    column1=forcing_loop_stack_column(istack)
	    row2=forcing_loop_stack_row(istack+1) 
	    column2=forcing_loop_stack_column(istack+1)
	  ELSE IF(istack .eq. forcing_loop_stack_length) THEN
	    row1=forcing_loop_stack_row(istack)
	    column1=forcing_loop_stack_column(istack)
	    row2=forcing_loop_stack_row(1) 
	    column2=forcing_loop_stack_column(1)
	  END IF  
	    Z_value=forcing_loop_stack_value(istack)

	    ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


            ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

	END DO

!--------------------------------------------------------------------------------------
!       STOP
	CYCLE kloop1
      ELSE
	CYCLE kloop1
      END IF
     END IF

      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(k,3) .ne. 0) THEN
         small_cell_column = int(k/3)+1
      ELSE
         small_cell_column = int(k/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(k) = forcing_loop_column(k)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = k
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_loops(i_row,k,cell_value(2)) 
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(k) = forcing_loop_column(k)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = k
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_loops(i_row,k,cell_value(1))
    ELSE
!      check=0
!      RETURN
       CYCLE kloop1
    END IF
  END DO kloop1

  ! Loop over the column
kloop2:  DO k=1,9
    IF (sudoku(k,j_column) .ne. 0) CYCLE
    IF (k .eq. i_row) CYCLE


        DO istack=2,forcing_loop_stack_length
          IF ((k .eq. forcing_loop_stack_row(istack)) .AND. &
                (j_column .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop2
          END IF
        END DO


    cell_k_numbers=sudoku_logic_numbers(k,j_column)
    IF (cell_k_numbers .ne. 2) CYCLE
    cell_value(1) = sudoku_logic(k,j_column,1)
    cell_value(2) = sudoku_logic(k,j_column,2)


    check=0
    check_loop_row =0
    check_loop_column =0
    check_loop_block =0
    DO ii=1,9
        IF (forcing_loop_row(ii) .ge. 2) THEN
           check_loop_row = check_loop_row+1
        END IF
    END DO
    DO ii=1,9
        IF (forcing_loop_column(ii) .ge. 2) THEN
            check_loop_column=check_loop_column+1
        END IF
    END DO
    DO ii=1,9
        IF (forcing_loop_block(ii) .ge. 1) THEN
           check_loop_block=check_loop_block+1
        END IF
    END DO

    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
                (check_loop_block .ge. 2)) THEN
           check=1
    END IF

    IF ((k .eq. forcing_loop_stack_row(1)) .AND. (j_column .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN

!----------------------------------------------------------------------
! Remove the number from the buddies of two adjacent squares
       DO istack=1,forcing_loop_stack_length
          IF (istack .ne. forcing_loop_stack_length) THEN
            row1=forcing_loop_stack_row(istack)
            column1=forcing_loop_stack_column(istack)
            row2=forcing_loop_stack_row(istack+1)
            column2=forcing_loop_stack_column(istack+1)
          ELSE IF(istack .eq. forcing_loop_stack_length) THEN
            row1=forcing_loop_stack_row(istack)
            column1=forcing_loop_stack_column(istack)
            row2=forcing_loop_stack_row(1)
            column2=forcing_loop_stack_column(1)
          END IF
            Z_value=forcing_loop_stack_value(istack)


            ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

            ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


              buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO
	

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

        END DO

!---------------------------------------------------------------------
!	STOP
	CYCLE kloop2
      ELSE
	CYCLE  kloop2
      END IF
     END IF

      ! Find the samll cell (block) that this square belongs to
      IF (mod(k,3) .ne. 0) THEN
         small_cell_row = int(k/3)+1
      ELSE
         small_cell_row = int(k/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column


    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(k) = forcing_loop_row(k)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = k
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_loops(k,j_column,cell_value(2))
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(k) = forcing_loop_row(k)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = k
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_loops(k,j_column,cell_value(1))
    ELSE
!      check=0
!      RETURN
       CYCLE kloop2
    END IF
  END DO kloop2

  ! Loop over the cells of the block (small cell)
             IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
jjloop1:       DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
		  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
		  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE

		  DO istack=2,forcing_loop_stack_length
		    IF ((ii_other .eq. forcing_loop_stack_row(istack)) .AND. &
			(jj_other .eq. forcing_loop_stack_column(istack))) THEN
			  CYCLE jjloop1
		    END IF
		  END DO

		  cell_k_numbers=sudoku_logic_numbers(ii_other,jj_other)
		  IF (cell_k_numbers .ne. 2) CYCLE
		  cell_value(1) = sudoku_logic(ii_other,jj_other,1)
		  cell_value(2) = sudoku_logic(ii_other,jj_other,2)

		  check=0
		  check_loop_row=0
		  check_loop_column=0
		  check_loop_block=0
    DO ii=1,9
        IF (forcing_loop_row(ii) .ge. 2) THEN
           check_loop_row = check_loop_row+1
        END IF
    END DO
    DO ii=1,9
        IF (forcing_loop_column(ii) .ge. 2) THEN
            check_loop_column=check_loop_column+1
        END IF
    END DO
    DO ii=1,9
        IF (forcing_loop_block(ii) .ge. 1) THEN
           check_loop_block=check_loop_block+1
        END IF
    END DO

    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
                (check_loop_block .ge. 2)) THEN
           check=1
    END IF

    IF ((ii_other .eq. forcing_loop_stack_row(1)) .AND. &
		(jj_other .eq. forcing_loop_stack_column(1))) THEN
!      IF (check .eq. 1) THEN
     IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN

!------------------------------------------------------------------------------
! Remove the number from the buddies of two adjacent squares
       DO istack=1,forcing_loop_stack_length
          IF (istack .ne. forcing_loop_stack_length) THEN
            row1=forcing_loop_stack_row(istack)
            column1=forcing_loop_stack_column(istack)
            row2=forcing_loop_stack_row(istack+1)
            column2=forcing_loop_stack_column(istack+1)
          ELSE IF(istack .eq. forcing_loop_stack_length) THEN
            row1=forcing_loop_stack_row(istack)
            column1=forcing_loop_stack_column(istack)
            row2=forcing_loop_stack_row(1)
            column2=forcing_loop_stack_column(1)
          END IF
            Z_value=forcing_loop_stack_value(istack)

            ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

            ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

        END DO


!------------------------------------------------------------------------------
!       STOP
	CYCLE jjloop1
      ELSE
	CYCLE jjloop1
      END IF
     END IF

      ! Find the samll cell (block) that this square belongs to
      IF (mod(ii_other,3) .ne. 0) THEN
         small_cell_row = int(ii_other/3)+1
      ELSE
         small_cell_row = int(ii_other/3)
      END IF
      IF (mod(jj_other,3) .ne. 0) THEN
         small_cell_column = int(jj_other/3)+1
      ELSE
         small_cell_column = int(jj_other/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(ii_other) = forcing_loop_row(ii_other)+1
      forcing_loop_column(jj_other) = forcing_loop_column(jj_other)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = ii_other
      forcing_loop_stack_column(forcing_loop_stack_length) = jj_other
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_loops(ii_other,jj_other,cell_value(2))
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(ii_other) = forcing_loop_row(ii_other)+1
      forcing_loop_column(jj_other) = forcing_loop_column(jj_other)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = ii_other
      forcing_loop_stack_column(forcing_loop_stack_length) = jj_other
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_loops(ii_other,jj_other,cell_value(1))
    ELSE
!      check=0
!      RETURN
       CYCLE jjloop1
    END IF
  END DO jjloop1
 END DO

!----------------------------------------------------------------------------


      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column


  forcing_loop_row(i_row) = forcing_loop_row(i_row)-1
  forcing_loop_column(j_column) = forcing_loop_column(j_column)-1
  forcing_loop_block(m) = forcing_loop_block(m)-1
  forcing_loop_stack_row(forcing_loop_stack_length)=0
  forcing_loop_stack_column(forcing_loop_stack_length)=0
  forcing_loop_stack_length=forcing_loop_stack_length-1
  


END SUBROUTINE find_forcing_loops

!-------------------------------------------------------------------------------- 
! initial-31 is used to test simple_forcing_chains subroutine
!---------------------------------------------------------------------------------

SUBROUTINE simple_forcing_chains

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,small_cell_row,small_cell_column,m
  INTEGER,DIMENSION(9) :: cell_value
  INTEGER :: cell_ij_numbers,ivalue
  INTEGER :: knumber,temp_number
  INTEGER,DIMENSION(9) :: temp_array


  ! For each square
  DO i_row = 1,9
    DO j_column = 1,9
!  DO i_row = 4,4
!    DO j_column = 6,6

      IF (sudoku(i_row,j_column) .ne. 0) CYCLE
      forcing_loop_stack_row = 0
      forcing_loop_stack_column = 0
      forcing_loop_stack_length = 0
      forcing_loop_row=0
      forcing_loop_column=0
      forcing_loop_block=0
      forcing_loop_stack_value=0
      cell_value=0
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column)

!      IF (cell_ij_numbers .ne. 2) CYCLE
!      cell_value(1) = sudoku_logic(i_row,j_column,1)
!      cell_value(2) = sudoku_logic(i_row,j_column,2)

      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
!      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)


      temp_number=0
      temp_array=0
      DO ivalue=1,cell_ij_numbers
	cell_value(ivalue) = sudoku_logic(i_row,j_column,ivalue)
	forcing_loop_initial_value=cell_value(ivalue)
	forcing_loop_stack_length = 1
	forcing_loop_stack_value(1) = forcing_loop_initial_value
	forcing_chain_check = 0
        forcing_loop_stack_row(forcing_loop_stack_length) = i_row
        forcing_loop_stack_column(forcing_loop_stack_length) = j_column
        CALL find_forcing_chains(i_row,j_column,cell_value(ivalue))
	IF (forcing_chain_check .eq. 0) THEN
	  temp_number=temp_number+1
	  temp_array(temp_number)=forcing_loop_initial_value
	END IF
      END DO

      IF (temp_number .lt. cell_ij_numbers) THEN

	DO knumber=1,cell_ij_numbers
	  sudoku_logic(i_row,j_column,knumber)=0
	END DO
	sudoku_logic_numbers(i_row,j_column) = temp_number
	DO knumber=1,temp_number
	  sudoku_logic(i_row,j_column,knumber) = temp_array(knumber)
	END DO
       END IF

    END DO
  END DO

END SUBROUTINE simple_forcing_chains

!---------------------------------------------------------------------------------

RECURSIVE SUBROUTINE find_forcing_chains(i_row,j_column,forcing_loop_value)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,forcing_loop_value
  INTEGER :: small_cell_row,small_cell_column,m,k
  INTEGER :: check_loop
  INTEGER,DIMENSION(2) :: cell_value
  INTEGER :: cell_k_numbers,check,ii,istack
  INTEGER :: check_loop_row,check_loop_block,check_loop_column
  INTEGER :: iblock_row,iblock_column,check_block
  INTEGER :: ii_other,jj_other


      IF (forcing_loop_stack_length .gt. 1) THEN
        DO istack=1,forcing_loop_stack_length-1
          IF ((i_row .eq. forcing_loop_stack_row(istack)) .AND. &
                (j_column .eq. forcing_loop_stack_column(istack))) THEN
                RETURN
          END IF
        END DO
      END IF

! Loop over the row
kloop1:  DO k=1,9
    IF (sudoku(i_row,k) .ne. 0) CYCLE
    IF (k .eq. j_column) CYCLE

        DO istack=2,forcing_loop_stack_length
          IF ((i_row .eq. forcing_loop_stack_row(istack)) .AND. &
                (k .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop1
          END IF
        END DO


!    cell_k_numbers=sudoku_logic_numbers(i_row,k)
!    IF (cell_k_numbers .ne. 2) CYCLE
!    cell_value(1) = sudoku_logic(i_row,k,1)
!    cell_value(2) = sudoku_logic(i_row,k,2)

    check = 0
    check_loop_row =0
    check_loop_column =0
    check_loop_block =0
!    DO ii=1,9
!        IF (forcing_loop_row(ii) .ge. 2) THEN
!           check_loop_row = check_loop_row+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_column(ii) .ge. 2) THEN
!            check_loop_column=check_loop_column+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_block(ii) .ge. 1) THEN
!           check_loop_block=check_loop_block+1
!        END IF
!    END DO

!    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
!                (check_loop_block .ge. 2)) THEN
!           check=1
!    END IF

    IF (forcing_loop_stack_length .ge. 3) THEN
	check = 1
    END IF

    IF ((i_row .eq. forcing_loop_stack_row(1)) .AND. (k .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN
!       STOP
	forcing_chain_check = 1
	RETURN
        CYCLE kloop1
      ELSE
        CYCLE kloop1
      END IF
     END IF

    cell_k_numbers=sudoku_logic_numbers(i_row,k)
    IF (cell_k_numbers .ne. 2) CYCLE
    cell_value(1) = sudoku_logic(i_row,k,1)
    cell_value(2) = sudoku_logic(i_row,k,2)


      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(k,3) .ne. 0) THEN
         small_cell_column = int(k/3)+1
      ELSE
         small_cell_column = int(k/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(k) = forcing_loop_column(k)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = k
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_chains(i_row,k,cell_value(2))
	IF (forcing_chain_check .eq. 1) THEN
		RETURN
	END IF
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(k) = forcing_loop_column(k)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = k
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_chains(i_row,k,cell_value(1))
	IF (forcing_chain_check .eq. 1) THEN
		RETURN
	END IF
    ELSE
!      check=0
!      RETURN
       CYCLE kloop1
    END IF
  END DO kloop1


  ! Loop over the column
kloop2:  DO k=1,9
    IF (sudoku(k,j_column) .ne. 0) CYCLE
    IF (k .eq. i_row) CYCLE


        DO istack=2,forcing_loop_stack_length
          IF ((k .eq. forcing_loop_stack_row(istack)) .AND. &
                (j_column .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop2
          END IF
        END DO


!    cell_k_numbers=sudoku_logic_numbers(k,j_column)
!    IF (cell_k_numbers .ne. 2) CYCLE
!    cell_value(1) = sudoku_logic(k,j_column,1)
!    cell_value(2) = sudoku_logic(k,j_column,2)

    check=0
    check_loop_row =0
    check_loop_column =0
    check_loop_block =0
!    DO ii=1,9
!        IF (forcing_loop_row(ii) .ge. 2) THEN
!           check_loop_row = check_loop_row+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_column(ii) .ge. 2) THEN
!            check_loop_column=check_loop_column+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_block(ii) .ge. 1) THEN
!           check_loop_block=check_loop_block+1
!        END IF
!    END DO
!
!    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
!                (check_loop_block .ge. 2)) THEN
!           check=1
!    END IF
     
    IF (forcing_loop_stack_length .ge. 3) THEN
	check = 1
    END IF

    IF ((k .eq. forcing_loop_stack_row(1)) .AND. (j_column .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN
	forcing_chain_check = 1
	RETURN
!       STOP
        CYCLE kloop2
      ELSE
        CYCLE  kloop2
      END IF
    END IF

    cell_k_numbers=sudoku_logic_numbers(k,j_column)
    IF (cell_k_numbers .ne. 2) CYCLE
    cell_value(1) = sudoku_logic(k,j_column,1)
    cell_value(2) = sudoku_logic(k,j_column,2)


      ! Find the samll cell (block) that this square belongs to
      IF (mod(k,3) .ne. 0) THEN
         small_cell_row = int(k/3)+1
      ELSE
         small_cell_row = int(k/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column


    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(k) = forcing_loop_row(k)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = k
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_chains(k,j_column,cell_value(2))
	IF (forcing_chain_check .eq. 1) THEN
	 RETURN
	END IF
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(k) = forcing_loop_row(k)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = k
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_chains(k,j_column,cell_value(1))
	IF (forcing_chain_check .eq. 1) THEN
	  RETURN
	END IF
    ELSE
!      check=0
!      RETURN
       CYCLE kloop2
    END IF
  END DO kloop2



  ! Loop over the cells of the block (small cell)
             IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
jjloop1:       DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE

                  DO istack=2,forcing_loop_stack_length
                    IF ((ii_other .eq. forcing_loop_stack_row(istack)) .AND. &
                        (jj_other .eq. forcing_loop_stack_column(istack))) THEN
                          CYCLE jjloop1
                    END IF
                  END DO

!                  cell_k_numbers=sudoku_logic_numbers(ii_other,jj_other)
!                  IF (cell_k_numbers .ne. 2) CYCLE
!                  cell_value(1) = sudoku_logic(ii_other,jj_other,1)
!                  cell_value(2) = sudoku_logic(ii_other,jj_other,2)

                  check=0
                  check_loop_row=0
                  check_loop_column=0
                  check_loop_block=0

!    DO ii=1,9
!        IF (forcing_loop_row(ii) .ge. 2) THEN
!           check_loop_row = check_loop_row+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_column(ii) .ge. 2) THEN
!            check_loop_column=check_loop_column+1
!        END IF
!    END DO
!    DO ii=1,9
!        IF (forcing_loop_block(ii) .ge. 1) THEN
!           check_loop_block=check_loop_block+1
!        END IF
!    END DO

!    IF ((check_loop_row .ge. 2) .AND. (check_loop_column .ge. 2) .AND. &
!                (check_loop_block .ge. 2)) THEN
!           check=1
!    END IF

    IF (forcing_loop_stack_length .ge. 3) THEN
	check = 1
    END IF

    IF ((ii_other .eq. forcing_loop_stack_row(1)) .AND. &
                (jj_other .eq. forcing_loop_stack_column(1))) THEN
!      IF (check .eq. 1) THEN
     IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!       STOP
	forcing_chain_check=1
	RETURN
        CYCLE jjloop1
      ELSE
        CYCLE jjloop1
      END IF
     END IF

                  cell_k_numbers=sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE
                  cell_value(1) = sudoku_logic(ii_other,jj_other,1)
                  cell_value(2) = sudoku_logic(ii_other,jj_other,2)


      ! Find the samll cell (block) that this square belongs to
      IF (mod(ii_other,3) .ne. 0) THEN
         small_cell_row = int(ii_other/3)+1
      ELSE
         small_cell_row = int(ii_other/3)
      END IF
      IF (mod(jj_other,3) .ne. 0) THEN
         small_cell_column = int(jj_other/3)+1
      ELSE
         small_cell_column = int(jj_other/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

    IF (cell_value(1) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(ii_other) = forcing_loop_row(ii_other)+1
      forcing_loop_column(jj_other) = forcing_loop_column(jj_other)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = ii_other
      forcing_loop_stack_column(forcing_loop_stack_length) = jj_other
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(2)

      CALL find_forcing_chains(ii_other,jj_other,cell_value(2))
	IF (forcing_chain_check .eq. 1) THEN
	  RETURN
	END IF
    ELSE IF (cell_value(2) .eq. forcing_loop_value) THEN
      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(ii_other) = forcing_loop_row(ii_other)+1
      forcing_loop_column(jj_other) = forcing_loop_column(jj_other)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = ii_other
      forcing_loop_stack_column(forcing_loop_stack_length) = jj_other
      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)

      CALL find_forcing_chains(ii_other,jj_other,cell_value(1))
	IF (forcing_chain_check .eq. 1) THEN
	   RETURN
	END IF
    ELSE
!      check=0
!      RETURN
       CYCLE jjloop1
    END IF
  END DO jjloop1
 END DO

!----------------------------------------------------------------------------


      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column


  forcing_loop_row(i_row) = forcing_loop_row(i_row)-1
  forcing_loop_column(j_column) = forcing_loop_column(j_column)-1
  forcing_loop_block(m) = forcing_loop_block(m)-1
  forcing_loop_stack_row(forcing_loop_stack_length)=0
  forcing_loop_stack_column(forcing_loop_stack_length)=0
  forcing_loop_stack_length=forcing_loop_stack_length-1



END SUBROUTINE find_forcing_chains

!--------------------------------------------------------------------------------
! initial-31 and initial-32 is used to test comprehensive_forcing_chains
!------------------------------------------------------------------------------

SUBROUTINE comprehensive_forcing_chains

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,small_cell_row,small_cell_column,m
  INTEGER,DIMENSION(9) :: cell_value
  INTEGER :: cell_ij_numbers,ivalue
  INTEGER,DIMENSION(9,9) :: sudoku_chain,sudoku_logic_numbers_chain
  INTEGER,DIMENSION(9,9,9) :: sudoku_logic_chain
  INTEGER :: pupu
  INTEGER :: knumber,temp_number
  INTEGER,DIMENSION(9) :: temp_array


  ! For each square
  DO i_row = 1,9
    DO j_column = 1,9
!  DO i_row = 3,3
!    DO j_column = 3,3

      IF (sudoku(i_row,j_column) .ne. 0) CYCLE
      forcing_loop_stack_row = 0
      forcing_loop_stack_column = 0
      forcing_loop_stack_length = 0
      forcing_loop_row=0
      forcing_loop_column=0
      forcing_loop_block=0
      forcing_loop_stack_value=0
      cell_value=0
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column)

!      IF (cell_ij_numbers .ne. 2) CYCLE
!      cell_value(1) = sudoku_logic(i_row,j_column,1)
!      cell_value(2) = sudoku_logic(i_row,j_column,2)

      ! Find the samll cell (block) that this square belongs to
      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
!      forcing_loop_stack_value(forcing_loop_stack_length) = cell_value(1)
      forcing_loop_start_block = m


      temp_number=0
      temp_array=0
      DO ivalue=1,cell_ij_numbers
        cell_value(ivalue) = sudoku_logic(i_row,j_column,ivalue)
        forcing_loop_initial_value=cell_value(ivalue)
!        forcing_loop_initial_value=3
        forcing_loop_stack_length = 1
        forcing_loop_stack_value(1) = forcing_loop_initial_value
        forcing_chain_check = 0
	forcing_chain_stack_check = 0
        forcing_loop_stack_row(forcing_loop_stack_length) = i_row
        forcing_loop_stack_column(forcing_loop_stack_length) = j_column
	sudoku_logic_numbers_chain = sudoku_logic_numbers
	sudoku_chain = sudoku
	sudoku_logic_chain = sudoku_logic
!        CALL find_comprehensive_forcing_chains(i_row,j_column,cell_value(ivalue), &
!			sudoku_chain,sudoku_logic_numbers_chain,sudoku_logic_chain)
	pupu = forcing_loop_initial_value
        CALL find_comprehensive_forcing_chains(i_row,j_column,pupu, &
			sudoku_chain,sudoku_logic_numbers_chain,sudoku_logic_chain)

        IF (forcing_chain_check .eq. 0) THEN
          temp_number=temp_number+1
          temp_array(temp_number)=forcing_loop_initial_value
        END IF

      END DO

      IF (temp_number .lt. cell_ij_numbers) THEN

        DO knumber=1,cell_ij_numbers
          sudoku_logic(i_row,j_column,knumber)=0
        END DO
        sudoku_logic_numbers(i_row,j_column) = temp_number
        DO knumber=1,temp_number
          sudoku_logic(i_row,j_column,knumber) = temp_array(knumber)
        END DO
       END IF


    END DO
  END DO


END SUBROUTINE comprehensive_forcing_chains

!------------------------------------------------------------------------------

RECURSIVE SUBROUTINE find_comprehensive_forcing_chains(i_row,j_column,forcing_loop_value, &
			sudoku_chain_old,sudoku_logic_numbers_chain_old, &
				sudoku_logic_chain_old)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,forcing_loop_value
  INTEGER,DIMENSION(9,9) :: sudoku_chain_old,sudoku_logic_numbers_chain_old
  INTEGER,DIMENSION(9,9) :: sudoku_chain_new,sudoku_logic_numbers_chain_new 
  INTEGER,DIMENSION(9,9,9) :: sudoku_logic_chain_old,sudoku_logic_chain_new
  INTEGER :: small_cell_row,small_cell_column,m,k
  INTEGER :: check_loop
  INTEGER,DIMENSION(2) :: cell_value
  INTEGER :: cell_k_numbers,check,ii,istack
  INTEGER :: check_loop_row,check_loop_block,check_loop_column
  INTEGER :: iblock_row,iblock_column,check_block
  INTEGER :: ii_other,jj_other
  INTEGER :: forcing_loop_value1
  INTEGER :: check_chain

 ! Loop over the row
 ! First find pins and forces for the squares in the row
 ! Make the sudoku logic number to 1 for this number
 ! then call forced moves..
 ! then call pinned moves..
 ! 1 is for row, 2 is for column and 3 is for block

      IF (mod(i_row,3) .ne. 0) THEN
         small_cell_row = int(i_row/3)+1
      ELSE
         small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
         small_cell_column = int(j_column/3)+1
      ELSE
         small_cell_column = int(j_column/3)
      END IF
      m=(small_cell_row-1)*3+small_cell_column

! Find if the buddy (same row, column or block) has the same forcing_loop_value
! as forcing_loop_initial_value
      check_chain = 0
      IF (i_row .eq. forcing_loop_stack_row(1)) THEN
	check_chain = 1
      END IF
      IF (j_column .eq. forcing_loop_stack_column(1)) THEN
	check_chain = 1
      END IF
      IF ( m .eq. forcing_loop_start_block) THEN
	check_chain = 1
      END IF
      IF ((check_chain .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value) &
		.AND. (forcing_loop_stack_length .ge. 3)) THEN

!	STOP
	forcing_chain_check = 1
 	RETURN
      END IF

      IF (forcing_loop_stack_length .ge. forcing_chain_stack_length_max) THEN
	forcing_chain_stack_check = 1
	RETURN
      END IF
     


 sudoku_chain_new = sudoku_chain_old
 sudoku_logic_numbers_chain_new = sudoku_logic_numbers_chain_old
 sudoku_logic_chain_new = sudoku_logic_chain_old
 sudoku_logic_numbers_chain_new(i_row,j_column) = 1
 sudoku_logic_chain_new(i_row,j_column,1) = forcing_loop_value
! sudoku_chain_new(i_row,j_column) = 0

 CALL Forced_moves_chain(i_row,j_column,1,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
				sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,1,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
				sudoku_logic_chain_new)

 CALL Forced_moves_chain(i_row,j_column,1,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,1,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)


kloop1:  DO k=1,9
    IF (sudoku(i_row,k) .ne. 0) CYCLE
    IF (k .eq. j_column) CYCLE

        DO istack=2,forcing_loop_stack_length
          IF ((i_row .eq. forcing_loop_stack_row(istack)) .AND. &
                (k .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop1
          END IF
        END DO

    check = 0

    IF (forcing_loop_stack_length .ge. 3) THEN
        check = 1
    END IF

    IF ((i_row .eq. forcing_loop_stack_row(1)) .AND. (k .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN
!       STOP
!        forcing_chain_check = 1
!        RETURN
        CYCLE kloop1
      ELSE
        CYCLE kloop1
      END IF
     END IF

     cell_k_numbers=sudoku_logic_numbers(i_row,k)
     IF (cell_k_numbers .lt. 2) CYCLE
     ! The new square in the chain should have a forced or pinned value
     IF (sudoku_logic_numbers_chain_new(i_row,k) .ne. 0) CYCLE
     forcing_loop_value = sudoku_chain_new(i_row,k)

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(i_row) = forcing_loop_row(i_row)+1
      forcing_loop_column(k) = forcing_loop_column(k)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = i_row
      forcing_loop_stack_column(forcing_loop_stack_length) = k
      forcing_loop_stack_value(forcing_loop_stack_length) = forcing_loop_value

	forcing_loop_value1 = forcing_loop_value
      CALL find_comprehensive_forcing_chains(i_row,k,forcing_loop_value1, &
		sudoku_chain_new,sudoku_logic_numbers_chain_new, &
			sudoku_logic_chain_new)
      IF (forcing_chain_check .eq. 1) THEN
	 RETURN
      END IF

      IF (forcing_chain_stack_check .eq. 1) THEN
	  RETURN
      END IF

  END DO kloop1
  
! Calling column

 
 sudoku_chain_new = sudoku_chain_old
 sudoku_logic_numbers_chain_new = sudoku_logic_numbers_chain_old
 sudoku_logic_chain_new = sudoku_logic_chain_old
 sudoku_logic_numbers_chain_new(i_row,j_column) = 1
! sudoku_logic_chain_new(i_row,j_column,1) = forcing_loop_value
 sudoku_logic_chain_new(i_row,j_column,1) = forcing_loop_stack_value(forcing_loop_stack_length)
! sudoku_chain_new(i_row,j_column) = 0

 

 CALL Forced_moves_chain(i_row,j_column,2,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,2,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)

 CALL Forced_moves_chain(i_row,j_column,2,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,2,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)


kloop2: DO k=1,9
   IF (sudoku(k,j_column) .ne. 0) CYCLE
   IF (k .eq. i_row) CYCLE

        DO istack=2,forcing_loop_stack_length
          IF ((k .eq. forcing_loop_stack_row(istack)) .AND. &
                (j_column .eq. forcing_loop_stack_column(istack))) THEN
                CYCLE kloop2
          END IF
        END DO

    check=0

   IF (forcing_loop_stack_length .ge. 3) THEN
        check = 1
    END IF

    IF ((k .eq. forcing_loop_stack_row(1)) .AND. (j_column .eq. forcing_loop_stack_column(1))) THEN
      IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!      IF (check .eq. 1) THEN
!        forcing_chain_check = 1
!        RETURN
        CYCLE kloop2
      ELSE
        CYCLE kloop2
      END IF
     END IF

     cell_k_numbers=sudoku_logic_numbers(k,j_column)
     IF (cell_k_numbers .lt. 2) CYCLE
     ! The new square in the chain should have a forced or pinned value
     IF (sudoku_logic_numbers_chain_new(k,j_column) .ne. 0) CYCLE
     forcing_loop_value = sudoku_chain_new(k,j_column)

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(k) = forcing_loop_row(k)+1
      forcing_loop_column(j_column) = forcing_loop_column(j_column)+1
      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = k
      forcing_loop_stack_column(forcing_loop_stack_length) = j_column
      forcing_loop_stack_value(forcing_loop_stack_length) = forcing_loop_value

	forcing_loop_value1 = forcing_loop_value
      CALL find_comprehensive_forcing_chains(k,j_column,forcing_loop_value1, &
                sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                        sudoku_logic_chain_new)
      IF (forcing_chain_check .eq. 1) THEN
         RETURN
      END IF

      IF (forcing_chain_stack_check .eq. 1) THEN
          RETURN
      END IF

END DO kloop2


  ! Loop over the cells of the block (small cell)
             IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

 sudoku_chain_new = sudoku_chain_old
 sudoku_logic_numbers_chain_new = sudoku_logic_numbers_chain_old
 sudoku_logic_chain_new = sudoku_logic_chain_old
 sudoku_logic_numbers_chain_new(i_row,j_column) = 1
! sudoku_logic_chain_new(i_row,j_column,1) = forcing_loop_value
sudoku_logic_chain_new(i_row,j_column,1) = forcing_loop_stack_value(forcing_loop_stack_length)
! sudoku_chain_new(i_row,j_column) = 0
 CALL Forced_moves_chain(i_row,j_column,3,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,3,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)

 CALL Forced_moves_chain(i_row,j_column,3,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)
 CALL Pinned_moves_chain(i_row,j_column,3,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
jjloop1:       DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE

                  DO istack=2,forcing_loop_stack_length
                    IF ((ii_other .eq. forcing_loop_stack_row(istack)) .AND. &
                        (jj_other .eq. forcing_loop_stack_column(istack))) THEN
                          CYCLE jjloop1
                    END IF
                  END DO

                  check=0

    IF (forcing_loop_stack_length .ge. 3) THEN
        check = 1
    END IF

    IF ((ii_other .eq. forcing_loop_stack_row(1)) .AND. &
                (jj_other .eq. forcing_loop_stack_column(1))) THEN
!      IF (check .eq. 1) THEN
     IF ((check .eq. 1) .AND. (forcing_loop_value .eq. forcing_loop_initial_value)) THEN
!       STOP
!        forcing_chain_check=1
!        RETURN
        CYCLE jjloop1
      ELSE
        CYCLE jjloop1
      END IF
     END IF

 
     cell_k_numbers=sudoku_logic_numbers(ii_other,jj_other)
     IF (cell_k_numbers .lt. 2) CYCLE
     ! The new square in the chain should have a forced or pinned value
     IF (sudoku_logic_numbers_chain_new(ii_other,jj_other) .ne. 0) CYCLE
     forcing_loop_value = sudoku_chain_new(ii_other,jj_other)

      forcing_loop_stack_length=forcing_loop_stack_length+1
      forcing_loop_row(ii_other) = forcing_loop_row(ii_other)+1
      forcing_loop_column(jj_other) = forcing_loop_column(jj_other)+1
!      forcing_loop_block(m) = forcing_loop_block(m)+1
      forcing_loop_stack_row(forcing_loop_stack_length) = ii_other
      forcing_loop_stack_column(forcing_loop_stack_length) = jj_other
      forcing_loop_stack_value(forcing_loop_stack_length) = forcing_loop_value

	forcing_loop_value1 = forcing_loop_value
      CALL find_comprehensive_forcing_chains(ii_other,jj_other,forcing_loop_value1, &
                sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                        sudoku_logic_chain_new)
      IF (forcing_chain_check .eq. 1) THEN
         RETURN
      END IF

      IF (forcing_chain_stack_check .eq. 1) THEN
          RETURN
      END IF

    END DO jjloop1
  END DO


  forcing_loop_row(i_row) = forcing_loop_row(i_row)-1
  forcing_loop_column(j_column) = forcing_loop_column(j_column)-1
!  forcing_loop_block(m) = forcing_loop_block(m)-1
  forcing_loop_stack_row(forcing_loop_stack_length)=0
  forcing_loop_stack_column(forcing_loop_stack_length)=0
  forcing_loop_stack_length=forcing_loop_stack_length-1
     

END SUBROUTINE find_comprehensive_forcing_chains
!---------------------------------------------------------------------------------

! RCB = row, column and block
SUBROUTINE Forced_moves_chain(i_row,j_column,RCB,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
			sudoku_logic_chain_new)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,RCB
  INTEGER,DIMENSION(9,9) :: sudoku_chain_new,sudoku_logic_numbers_chain_new
  INTEGER,DIMENSION(9,9,9) :: sudoku_logic_chain_new
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: i,j
  INTEGER :: ith,jth
  INTEGER :: row_k,column_k
  INTEGER :: temp_number
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: check_number,cell_other_numbers,cell_other_logic_number
  INTEGER :: inumber,ii_other,jj_other
  INTEGER :: iii_other,jjj_other
  INTEGER :: ii,jj

  


  ! Find forced moves in row (loop over columns of i_row)
  IF (RCB .eq. 1) THEN
   DO jj=1,9
    IF ((sudoku_logic_numbers_chain_new(i_row,jj) == 1)) THEN
      sudoku_chain_new(i_row,jj) = sudoku_logic_chain_new(i_row,jj,1)
      sudoku_logic_numbers_chain_new(i_row,jj) = 0
      sudoku_logic_chain_new(i_row,jj,1) = 0
      check_number = sudoku_chain_new(i_row,jj)


    DO j=1,9
     temp_number=0
     temp_array=0
     IF (sudoku_chain_new(i_row,j) .ne. 0) CYCLE
     IF (j .eq. jj) CYCLE
     cell_other_numbers = sudoku_logic_numbers_chain_new(i_row,j)
     DO inumber=1,cell_other_numbers
       cell_other_logic_number=sudoku_logic_chain_new(i_row,j,inumber)
       IF (cell_other_logic_number .ne. check_number) THEN
	 temp_number=temp_number+1
	 temp_array(temp_number) = cell_other_logic_number
       END IF
     END DO
     !Update the sudoku logic numbers and sudoku_logic_array of other cells
     DO inumber=1,sudoku_logic_numbers_chain_new(i_row,j)
       sudoku_logic_chain_new(i_row,j,inumber) = 0
     END DO
     sudoku_logic_numbers_chain_new(i_row,j) = temp_number
     DO inumber=1,temp_number
       sudoku_logic_chain_new(i_row,j,inumber) = temp_array(inumber)
     END DO
   END DO 

  END IF
 END DO

! Find forced moves in column (loop over rows of j_column)
 ELSE IF (RCB .eq. 2) THEN
  DO ii=1,9
    IF (sudoku_logic_numbers_chain_new(ii,j_column) == 1) THEN
      sudoku_chain_new(ii,j_column) = sudoku_logic_chain_new(ii,j_column,1)
      sudoku_logic_numbers_chain_new(ii,j_column) = 0
      sudoku_logic_chain_new(ii,j_column,1) = 0
      check_number = sudoku_chain_new(ii,j_column)

      DO i=1,9
	temp_number=0
	temp_array=0
	IF (sudoku_chain_new(i,j_column) .ne. 0) CYCLE
        IF (i .eq. ii) CYCLE
   	cell_other_numbers = sudoku_logic_numbers_chain_new(i,j_column)
	DO inumber=1,cell_other_numbers
	  cell_other_logic_number=sudoku_logic_chain_new(i,j_column,inumber)
	  IF (cell_other_logic_number .ne. check_number) THEN
	    temp_number=temp_number+1
	    temp_array(temp_number) = cell_other_logic_number
	  END IF
 	END DO
        ! Update the sudoku logic numbers and sudoku_logic_array of other cells
        DO inumber=1,sudoku_logic_numbers_chain_new(i,j_column)
	  sudoku_logic_chain_new(i,j_column,inumber) = 0
	END DO
	sudoku_logic_numbers_chain_new(i,j_column) = temp_number
	DO inumber=1,temp_number
	  sudoku_logic_chain_new(i,j_column,inumber) = temp_array(inumber)
	END DO
      END DO

    END IF
  END DO

 ELSE IF (RCB .eq. 3) THEN

      ! Find the small cell to which this cell belongs
      IF (mod(i_row,3) .ne. 0) THEN
        small_cell_row = int(i_row/3)+1
      ELSE
        small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
        small_cell_column = int(j_column/3)+1
      ELSE
        small_cell_column = int(j_column/3)
      END IF
    
    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

	    DO iii_other=row_k,row_k+2
	      DO jjj_other=column_k,column_k+2
	        IF (sudoku_logic_numbers_chain_new(iii_other,jjj_other) == 1) THEN
		  sudoku_chain_new(iii_other,jjj_other) = &
			sudoku_logic_chain_new(iii_other,jjj_other,1)
		  sudoku_logic_numbers_chain_new(iii_other,jjj_other) = 0
		  sudoku_logic_chain_new(iii_other,jjj_other,1) = 0	  
	          check_number = sudoku_chain_new(iii_other,jjj_other)

                DO ii_other=row_k,row_k+2
                  DO jj_other=column_k,column_k+2
                    temp_number=0
                    temp_array=0
                    IF (sudoku_chain_new(ii_other,jj_other) .ne. 0) CYCLE
                    IF ((ii_other .eq. iii_other) .AND. (jj_other .eq. jjj_other)) CYCLE
                    cell_other_numbers=sudoku_logic_numbers_chain_new(ii_other,jj_other)
                    DO inumber=1,cell_other_numbers
                      cell_other_logic_number=sudoku_logic_chain_new(ii_other,jj_other,inumber)
                      IF (cell_other_logic_number .ne. check_number) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number
                      END IF
                    END DO
                      ! Update the sudoku_logic_numbers and sudoku_logic_array of those cells
                      DO inumber=1,sudoku_logic_numbers_chain_new(ii_other,jj_other)
                        sudoku_logic_chain_new(ii_other,jj_other,inumber) = 0
                      END DO
                      sudoku_logic_numbers_chain_new(ii_other,jj_other) = temp_number
                      DO inumber=1,temp_number
                        sudoku_logic_chain_new(ii_other,jj_other,inumber) = temp_array(inumber)
                      END DO
                    END DO
                  END DO

	     END IF
	   END DO
	END DO
   
   END IF
 

END SUBROUTINE Forced_moves_chain
!----------------------------------------------------------------------------

SUBROUTINE Pinned_moves_chain(i_row,j_column,RCB,sudoku_chain_new,sudoku_logic_numbers_chain_new, &
                                sudoku_logic_chain_new)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,RCB
  INTEGER,DIMENSION(9,9) :: sudoku_chain_new,sudoku_logic_numbers_chain_new
  INTEGER,DIMENSION(9,9,9) :: sudoku_logic_chain_new
  INTEGER ::i,j,k
  INTEGER,DIMENSION(9) :: pinned_squares
  INTEGER :: cell_other_numbers,inumber,cell_other_logic_number
  INTEGER :: cell_other_numbers_1,inumber_1
  INTEGER :: small_cell_row,small_cell_column,row_k,column_k
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: temp_number,cell_other_numbers_2,knumber,cell_other_logic_number_2
  INTEGER :: ii_other,jj_other,cell_other_numbers_3,cell_other_logic_number_3

 IF (RCB .eq. 1) THEN
! IF (RCB .eq. 2) THEN
  pinned_squares=0
  DO j=1,9
    IF (sudoku_chain_new(i_row,j) .ne. 0) THEN
	pinned_squares(sudoku_chain_new(i_row,j)) = 5
        CYCLE
    END IF
    cell_other_numbers=sudoku_logic_numbers_chain_new(i_row,j)
    DO inumber=1,cell_other_numbers
      cell_other_logic_number=sudoku_logic_chain_new(i_row,j,inumber)
      pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
    END DO
  END DO

inumber_loop:    DO inumber=1,9
      IF (pinned_squares(inumber) .eq. 1) THEN
        DO j=1,9
          IF (sudoku_chain_new(i_row,j) .ne. 0) CYCLE
          cell_other_numbers_1 = sudoku_logic_numbers_chain_new(i_row,j)
          DO inumber_1=1,cell_other_numbers_1
            cell_other_logic_number=sudoku_logic_chain_new(i_row,j,inumber_1)
             IF (cell_other_logic_number .eq. inumber) THEN
                sudoku_chain_new(i_row,j) = inumber
                DO k=1,cell_other_numbers
                  sudoku_logic_chain_new(i_row,j,k) = 0
                END DO
                sudoku_logic_numbers_chain_new(i_row,j) = 0
GO TO 100
!----------------------------------------------------------------------
! IMP: I think we do not need to do this
! Remove the number from sudoku logic numbers of other cells in the column
                DO k=1,9
                   temp_number=0
                   temp_array=0
                   IF (sudoku_chain_new(k,j) .ne. 0) CYCLE
                   cell_other_numbers_2 = sudoku_logic_numbers_chain_new(k,j)
                   DO knumber=1,cell_other_numbers_2
                     cell_other_logic_number_2 = sudoku_logic_chain_new(k,j,knumber)
                     IF (cell_other_logic_number_2 .ne. inumber) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number_2
                     END IF
                   END DO
                   ! Update the sudoku_logic_numbers and sudoku_logic_array of those cells
                   DO knumber=1,sudoku_logic_numbers_chain_new(k,j)
                     sudoku_logic_chain_new(k,j,knumber) = 0
                   END DO
                   sudoku_logic_numbers_chain_new(k,j) = temp_number
                   DO knumber=1,temp_number
                     sudoku_logic_chain_new(k,j,knumber) = temp_array(knumber)
                   END DO
                END DO
!----------------------------------------------------------------------
100 CONTINUE 

                CYCLE inumber_loop
             END IF
          END DO
        END DO
      END IF
     END DO inumber_loop

 ELSE IF (RCB .eq. 2) THEN
! ELSE IF (RCB .eq. 1) THEN

    pinned_squares = 0
    DO i=1,9
      IF (sudoku_chain_new(i,j_column) .ne. 0) THEN
! IMP: put this number in the pinned_squares as any number other than 1 (we put as 5)
        pinned_squares(sudoku_chain_new(i,j_column)) = 5
        CYCLE
      END IF
      cell_other_numbers = sudoku_logic_numbers_chain_new(i,j_column)
      DO inumber=1,cell_other_numbers
        cell_other_logic_number = sudoku_logic_chain_new(i,j_column,inumber)
        pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
      END DO
    END DO

jnumber_loop:    DO inumber=1,9
      IF (pinned_squares(inumber) .eq. 1) THEN
        DO i=1,9
          IF (sudoku_chain_new(i,j_column) .ne. 0) CYCLE
          cell_other_numbers_1 = sudoku_logic_numbers_chain_new(i,j_column)
          DO inumber_1=1,cell_other_numbers_1
            cell_other_logic_number=sudoku_logic_chain_new(i,j_column,inumber_1)
             IF (cell_other_logic_number .eq. inumber) THEN
                sudoku_chain_new(i,j_column) = inumber
                DO k=1,cell_other_numbers
                  sudoku_logic_chain_new(i,j_column,k) = 0
                END DO
                sudoku_logic_numbers_chain_new(i,j_column) = 0
GO TO 200
!---------------------------------------------------------------------------
! Remove the number from sudoku logic numbers of other cells in the row
! IMP:: check this.. I think we do not need to do this
                DO k=1,9
                   temp_number=0
                   temp_array=0
                   IF (sudoku_chain_new(i,k) .ne. 0) CYCLE
                   cell_other_numbers_2 = sudoku_logic_numbers_chain_new(i,k)
                   DO knumber=1,cell_other_numbers_2
                     cell_other_logic_number_2 = sudoku_logic_chain_new(i,k,knumber)
                     IF (cell_other_logic_number_2 .ne. inumber) THEN
                        temp_number=temp_number+1
                        temp_array(temp_number) = cell_other_logic_number_2
                     END IF
                   END DO
                   ! Update the sudoku_logic_numbers and sudoku_logic_array of those cells
                   DO knumber=1,sudoku_logic_numbers_chain_new(i,k)
                     sudoku_logic_chain_new(i,k,knumber) = 0
                   END DO
                   sudoku_logic_numbers_chain_new(i,k) = temp_number
                   DO knumber=1,temp_number
                     sudoku_logic_chain_new(i,k,knumber) = temp_array(knumber)
                   END DO
                END DO
!---------------------------------------------------------------------------
200 CONTINUE

                CYCLE jnumber_loop
             END IF
          END DO
        END DO
      END IF
     END DO jnumber_loop

 ELSE IF (RCB .eq. 3) THEN

      pinned_squares = 0
      ! Find the small cell to which this cell belongs
      IF (mod(i_row,3) .ne. 0) THEN
        small_cell_row = int(i_row/3)+1
      ELSE
        small_cell_row = int(i_row/3)
      END IF
      IF (mod(j_column,3) .ne. 0) THEN
        small_cell_column = int(j_column/3)+1
      ELSE
        small_cell_column = int(j_column/3)
      END IF

    IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 1)) THEN
        row_k=1
        column_k=1
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 2)) THEN
        row_k=1
        column_k=4
    ELSE IF ((small_cell_row .eq. 1) .AND. (small_cell_column .eq. 3)) THEN
        row_k=1
        column_k=7
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 1)) THEN
        row_k=4
        column_k=1
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 2)) THEN
        row_k=4
        column_k=4
    ELSE IF ((small_cell_row .eq. 2) .AND. (small_cell_column .eq. 3)) THEN
        row_k=4
        column_k=7
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 1)) THEN
        row_k=7
        column_k=1
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 2)) THEN
        row_k=7
        column_k=4
    ELSE IF ((small_cell_row .eq. 3) .AND. (small_cell_column .eq. 3)) THEN
        row_k=7
        column_k=7
    END IF

   DO ii_other=row_k,row_k+2
     DO jj_other=column_k,column_k+2
        IF (sudoku_chain_new(ii_other,jj_other) .ne. 0) THEN
          pinned_squares(sudoku_chain_new(ii_other,jj_other)) = 5
          CYCLE
        END IF
        cell_other_numbers = sudoku_logic_numbers_chain_new(ii_other,jj_other)
        DO inumber=1,cell_other_numbers
          cell_other_logic_number=sudoku_logic_chain_new(ii_other,jj_other,inumber)
          pinned_squares(cell_other_logic_number)=pinned_squares(cell_other_logic_number)+1
        END DO
      END DO
     END DO

     DO ii_other=row_k,row_k+2
       DO jj_other=column_k,column_k+2

     cell_other_numbers=sudoku_logic_numbers_chain_new(ii_other,jj_other)
     DO inumber=1,cell_other_numbers
        cell_other_logic_number=sudoku_logic_chain_new(ii_other,jj_other,inumber)
        IF (pinned_squares(cell_other_logic_number) .eq. 1) THEN
           sudoku_chain_new(ii_other,jj_other) = cell_other_logic_number
           DO k=1,cell_other_numbers
             sudoku_logic_chain_new(ii_other,jj_other,k) = 0
           END DO
           sudoku_logic_numbers_chain_new(ii_other,jj_other) = 0
           EXIT
        END IF
      END DO

    END DO
  END DO
 
 END IF


END SUBROUTINE Pinned_moves_chain

!---------------------------------------------------------------------------
