!-----------------------------------------------------
! initial-33 and initial-35 is used to test XY_wings
!----------------------------------------------------

SUBROUTINE XY_wings

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,small_cell_row,small_cell_column,m
  INTEGER,DIMENSION(2) :: cell_value
  INTEGER :: cell_ij_numbers,cell_k_numbers
  INTEGER :: check_xz_wing,check_yz_wing
  INTEGER :: ii_other,jj_other,iii,jj,jjj,ii
  INTEGER :: Y_value,Z_value,X_value
  INTEGER :: check_block,iblock_column,iblock_row,iblock,check_value
  INTEGER :: ii_other1,jj_other1
  INTEGER,DIMENSION(25) :: buddies_row_X,buddies_row_Y,buddies_row_XY
  INTEGER,DIMENSION(25) :: buddies_column_X,buddies_column_Y,buddies_column_XY
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: temp_number,inumber,knumber
  INTEGER :: buddy,buddy_xy,column_buddy_xy,row_buddy_xy
  INTEGER :: column_x_buddy,column_y_buddy,ibuddy,row_x_buddy,row_y_buddy
  INTEGER :: cell_ij_logic_number,j,i,jbuddy
  INTEGER :: ii_other2,jj_other2

  ! For each square
  DO i_row=1,9
    DO j_column=1,9

      IF (sudoku(i_row,j_column) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column)

      IF (cell_ij_numbers .ne. 2) CYCLE
      cell_value(1) = sudoku_logic(i_row,j_column,1)
      cell_value(2) = sudoku_logic(i_row,j_column,2) 

      ! Loop over columns of i_row
      DO jj=1,9
	check_xz_wing=0
        IF (jj .eq. j_column) CYCLE
	IF (sudoku(i_row,jj) .ne. 0) CYCLE
	cell_k_numbers=sudoku_logic_numbers(i_row,jj)
	IF (cell_k_numbers .ne. 2) CYCLE

	IF (sudoku_logic(i_row,jj,1) .eq. cell_value(1)) THEN
	  X_value = sudoku_logic(i_row,jj,1)
	  Z_value = sudoku_logic(i_row,jj,2)
	  check_xz_wing = 1
	ELSE IF (sudoku_logic(i_row,jj,2) .eq. cell_value(1)) THEN
	  X_value = sudoku_logic(i_row,jj,2)
	  Z_value = sudoku_logic(i_row,jj,1)
	  check_xz_wing = 1
	END IF

	IF (check_xz_wing .eq. 1) THEN
	  ! Loop over the columns of i_row
	  DO jjj=1,9
	    check_yz_wing=0	
	    IF (jjj .eq. j_column) CYCLE
	    IF (jjj .eq. jj) CYCLE
	    IF (sudoku(i_row,jjj) .ne. 0) CYCLE
	    cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
	    IF (cell_k_numbers .ne. 2) CYCLE

  	    IF (sudoku_logic(i_row,jjj,1) .eq. cell_value(2) .AND. &
			sudoku_logic(i_row,jjj,2) .eq. Z_value) THEN
		Y_value = sudoku_logic(i_row,jjj,1)
		check_yz_wing = 1
	    ELSE IF (sudoku_logic(i_row,jjj,2) .eq. cell_value(2) .AND. &
			sudoku_logic(i_row,jjj,1) .eq. Z_value) THEN
		Y_value = sudoku_logic(i_row,jjj,2)
		check_yz_wing = 1
	    END IF

	    IF (check_yz_wing .eq. 1) THEN
		! Remove Z_value from the buddies of xz and yz squares
		! IMP: Should we return to the original square if we find a XY wing

!---------------------------------------------------------------------------
		! Find buddies of i_row and jj
		buddy=0
		DO j=1,9
		  IF (j .eq. jj) CYCLE
		  buddy=buddy+1
		  buddies_row_X(buddy) = i_row
		  buddies_column_X(buddy) = j	
		END DO
		DO i=1,9
		  IF (i .eq. i_row) CYCLE
		  buddy=buddy+1
		  buddies_row_X(buddy) = i
		  buddies_column_X(buddy) = jj
		END DO	

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jj,3) .ne. 0) THEN
                 small_cell_column = int(jj/3)+1
              ELSE
                 small_cell_column = int(jj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

		  IF (ii_other2 .eq. i_row) CYCLE
		  IF (jj_other2 .eq. jj) CYCLE
		  buddy=buddy+1
		  buddies_row_X(buddy) = ii_other2
		  buddies_column_X(buddy) = jj_other2
		END DO
	      END DO


                ! Find buddies of i_row and jjj
                buddy=0
                DO j=1,9
                  IF (j .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i_row
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. i_row) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jjj
                END DO

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jjj,3) .ne. 0) THEN
                 small_cell_column = int(jjj/3)+1
              ELSE
                 small_cell_column = int(jjj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. i_row) CYCLE
                  IF (jj_other2 .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

	      buddy_xy=0
	      DO ibuddy=1,20
		row_x_buddy = buddies_row_X(ibuddy)
		column_x_buddy = buddies_column_X(ibuddy)
		DO jbuddy=1,20
		  row_y_buddy = buddies_row_Y(jbuddy)
		  column_y_buddy = buddies_column_Y(jbuddy)
	IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
		  buddy_xy=buddy_xy+1
		  buddies_row_XY(buddy_xy) = row_x_buddy
		  buddies_column_XY(buddy_xy) = column_x_buddy
		  EXIT
	END IF
		END DO
	      END DO

	
! Remove the number Z_value from the common buddies
	      DO ibuddy=1,buddy_xy
		 row_buddy_xy = buddies_row_XY(ibuddy)
		 column_buddy_xy = buddies_column_XY(ibuddy)
		 temp_array=0
		 temp_number=0
		 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
		 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
		 DO inumber=1,cell_ij_numbers
		   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
		   IF (cell_ij_logic_number .eq. Z_value) CYCLE
		   temp_number = temp_number+1
		   temp_array(temp_number) = cell_ij_logic_number
		 END DO

               ! Print out the values

	 	 DO knumber=1,cell_ij_numbers
		  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
		 END DO
		 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
		 DO knumber=1,temp_number
		   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
		 END DO

	     END DO

!--------------------------------------------------------------------

	    END IF
         END DO

! Loop over the rows of j_column
	 DO iii=1,9
	   check_yz_wing=0
	   IF (iii .eq. i_row) CYCLE
	     IF (sudoku(iii,j_column) .ne. 0) CYCLE
	     cell_k_numbers=sudoku_logic_numbers(iii,j_column)	
	     IF (cell_k_numbers .ne. 2) CYCLE

	     IF (sudoku_logic(iii,j_column,1) .eq. cell_value(2) .AND. &
			sudoku_logic(iii,j_column,2) .eq. Z_value) THEN
		Y_value = sudoku_logic(iii,j_column,1)
		check_yz_wing = 1
	     ELSE IF (sudoku_logic(iii,j_column,2) .eq. cell_value(2) .AND. &
			sudoku_logic(iii,j_column,1) .eq. Z_value) THEN
		Y_value = sudoku_logic(iii,j_column,2)
		check_yz_wing = 1
	     END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-----------------------------------------------------------------------------------
                ! Find buddies of i_row and jj
                buddy=0
                DO j=1,9
                  IF (j .eq. jj) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i_row
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. i_row) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = jj
                END DO

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jj,3) .ne. 0) THEN
                 small_cell_column = int(jj/3)+1
              ELSE
                 small_cell_column = int(jj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. i_row) CYCLE
                  IF (jj_other2 .eq. jj) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of iii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = iii
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. iii) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = j_column
                END DO


              IF (mod(iii,3) .ne. 0) THEN
                 small_cell_row = int(iii/3)+1
              ELSE
                 small_cell_row = int(iii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. iii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
             DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!----------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
		  check_yz_wing = 0

		  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
		  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE
		
		  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
		  IF (cell_k_numbers .ne. 2) CYCLE

		  IF (sudoku_logic(ii_other,jj_other,1) .eq. cell_value(2) .AND. &
				sudoku_logic(ii_other,jj_other,2) .eq. Z_value) THEN
			Y_value = sudoku_logic(ii_other,jj_other,1)
		        check_yz_wing = 1
		  ELSE IF (sudoku_logic(ii_other,jj_other,2) .eq. cell_value(2) .AND. &
				sudoku_logic(ii_other,jj_other,1) .eq. Z_value) THEN
			 Y_value = sudoku_logic(ii_other,jj_other,2)
			 check_yz_wing = 1
		  END IF
	
            	  IF (check_yz_wing .eq. 1) THEN
                	! Remove Z_value from the buddies of xz and yz squares
                	! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------------------------

                ! Find buddies of i_row and jj
                buddy=0
                DO j=1,9
                  IF (j .eq. jj) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i_row
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. i_row) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = jj
                END DO

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jj,3) .ne. 0) THEN
                 small_cell_column = int(jj/3)+1
              ELSE
                 small_cell_column = int(jj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. i_row) CYCLE
                  IF (jj_other2 .eq. jj) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

	      ! Find buddies of ii_other, jj_other
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jj_other
                END DO

              IF (mod(ii_other,3) .ne. 0) THEN
                 small_cell_row = int(ii_other/3)+1
              ELSE
                 small_cell_row = int(ii_other/3)
              END IF
              IF (mod(jj_other,3) .ne. 0) THEN
                 small_cell_column = int(jj_other/3)+1
              ELSE
                 small_cell_column = int(jj_other/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other) CYCLE
                  IF (jj_other2 .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO




!------------------------------------------------------------------------------------------
            	  END IF

		END DO
	      END DO
! End If over xy wing
	    END IF
! End loop over columns of i_row
         END DO

! Loop over rows of j_column
	DO ii=1,9
	  check_xz_wing=0
	  IF (ii .eq. i_row) CYCLE
	  IF (sudoku(ii,j_column) .ne. 0) CYCLE
	  cell_k_numbers=sudoku_logic_numbers(ii,j_column)
	  IF (cell_k_numbers .ne. 2) CYCLE

	  IF (sudoku_logic(ii,j_column,1) .eq. cell_value(1)) THEN
	    X_value = sudoku_logic(ii,j_column,1)
	    Z_value = sudoku_logic(ii,j_column,2)
	    check_xz_wing=1
	  ELSE IF (sudoku_logic(ii,j_column,2) .eq. cell_value(1)) THEN
	    X_value = sudoku_logic(ii,j_column,2)
	    Z_value = sudoku_logic(ii,j_column,1)
	    check_xz_wing=1
	  END IF

        IF (check_xz_wing .eq. 1) THEN
          ! Loop over the columns of i_row
          DO jjj=1,9
            check_yz_wing=0
            IF (jjj .eq. j_column) CYCLE
            IF (sudoku(i_row,jjj) .ne. 0) CYCLE
            cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
            IF (cell_k_numbers .ne. 2) CYCLE

            IF (sudoku_logic(i_row,jjj,1) .eq. cell_value(2) .AND. &
                        sudoku_logic(i_row,jjj,2) .eq. Z_value) THEN
                Y_value = sudoku_logic(i_row,jjj,1)
                check_yz_wing = 1
            ELSE IF (sudoku_logic(i_row,jjj,2) .eq. cell_value(2) .AND. &
                        sudoku_logic(i_row,jjj,1) .eq. Z_value) THEN
                Y_value = sudoku_logic(i_row,jjj,2)
                check_yz_wing = 1
            END IF

            IF (check_yz_wing .eq. 1) THEN

                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------------------

	        ! Find buddies of ii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = j_column
                END DO

              IF (mod(ii,3) .ne. 0) THEN
                 small_cell_row = int(ii/3)+1
              ELSE
                 small_cell_row = int(ii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

               ! Find buddies of i_row and jjj
                buddy=0
                DO j=1,9
                  IF (j .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i_row
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. i_row) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jjj
                END DO

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jjj,3) .ne. 0) THEN
                 small_cell_column = int(jjj/3)+1
              ELSE
                 small_cell_column = int(jjj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. i_row) CYCLE
                  IF (jj_other2 .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!------------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the rows of j_column
         DO iii=1,9
           check_yz_wing=0
           IF (iii .eq. i_row) CYCLE
	   IF (iii .eq. ii) CYCLE
             IF (sudoku(iii,j_column) .ne. 0) CYCLE
             cell_k_numbers=sudoku_logic_numbers(iii,j_column)
             IF (cell_k_numbers .ne. 2) CYCLE

             IF (sudoku_logic(iii,j_column,1) .eq. cell_value(2) .AND. &
                        sudoku_logic(iii,j_column,2) .eq. Z_value) THEN
                Y_value = sudoku_logic(iii,j_column,1)
                check_yz_wing = 1
             ELSE IF (sudoku_logic(iii,j_column,2) .eq. cell_value(2) .AND. &
                        sudoku_logic(iii,j_column,1) .eq. Z_value) THEN
                Y_value = sudoku_logic(iii,j_column,2)
                check_yz_wing = 1
             END IF

            IF (check_yz_wing .eq. 1) THEN

                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-----------------------------------------------------------------------------------------
                ! Find buddies of ii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = j_column
                END DO

              IF (mod(ii,3) .ne. 0) THEN
                 small_cell_row = int(ii/3)+1
              ELSE
                 small_cell_row = int(ii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of iii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = iii
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. iii) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = j_column
                END DO

              IF (mod(iii,3) .ne. 0) THEN
                 small_cell_row = int(iii/3)+1
              ELSE
                 small_cell_row = int(iii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. iii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
             DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO


! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

!----------------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  check_yz_wing = 0

                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE

                  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE

                  IF (sudoku_logic(ii_other,jj_other,1) .eq. cell_value(2) .AND. &
                                sudoku_logic(ii_other,jj_other,2) .eq. Z_value) THEN
                        Y_value = sudoku_logic(ii_other,jj_other,1)
                        check_yz_wing = 1
                  ELSE IF (sudoku_logic(ii_other,jj_other,2) .eq. cell_value(2) .AND. &
                                sudoku_logic(ii_other,jj_other,1) .eq. Z_value) THEN
                         Y_value = sudoku_logic(ii_other,jj_other,2)
                         check_yz_wing = 1
                  END IF

                  IF (check_yz_wing .eq. 1) THEN

                        ! Remove Z_value from the buddies of xz and yz squares
                        ! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------------------------

                ! Find buddies of ii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = j_column
                END DO

              IF (mod(ii,3) .ne. 0) THEN
                 small_cell_row = int(ii/3)+1
              ELSE
                 small_cell_row = int(ii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

              ! Find buddies of ii_other, jj_other
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jj_other
                END DO

             IF (mod(ii_other,3) .ne. 0) THEN
                 small_cell_row = int(ii_other/3)+1
              ELSE
                 small_cell_row = int(ii_other/3)
              END IF
              IF (mod(jj_other,3) .ne. 0) THEN
                 small_cell_column = int(jj_other/3)+1
              ELSE
                 small_cell_column = int(jj_other/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other) CYCLE
                  IF (jj_other2 .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO

!------------------------------------------------------------------------------------------
                  END IF

                END DO
              END DO
! End If over xy wing
	    END IF
! End loop over rows of j_column
	  END DO

! Loop over blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other1=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other1=(iblock_column-1)*3+1,(iblock_column*3)
	
	           check_xz_wing=0
		   IF ((ii_other1 .eq. i_row) .AND. (jj_other1 .eq. j_column)) CYCLE
		   IF (sudoku(ii_other1,jj_other1) .ne. 0) CYCLE
		   cell_k_numbers=sudoku_logic_numbers(ii_other1,jj_other1)
		   IF (cell_k_numbers .ne. 2) CYCLE

		   IF (sudoku_logic(ii_other1,jj_other1,1) .eq. cell_value(1)) THEN
		     X_value = sudoku_logic(ii_other1,jj_other1,1)
		     Z_Value = sudoku_logic(ii_other1,jj_other1,2)
		     check_xz_wing=1
		  ELSE IF (sudoku_logic(ii_other1,jj_other1,2) .eq. cell_value(1)) THEN
		     X_value = sudoku_logic(ii_other1,jj_other1,2)
		     Z_value = sudoku_logic(ii_other1,jj_other1,1)
		     check_xz_wing=1
		  END IF

        IF (check_xz_wing .eq. 1) THEN
          ! Loop over the columns of i_row
          DO jjj=1,9
            check_yz_wing=0
            IF (jjj .eq. j_column) CYCLE
            IF (sudoku(i_row,jjj) .ne. 0) CYCLE
            cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
            IF (cell_k_numbers .ne. 2) CYCLE

            IF (sudoku_logic(i_row,jjj,1) .eq. cell_value(2) .AND. &
                        sudoku_logic(i_row,jjj,2) .eq. Z_value) THEN
                Y_value = sudoku_logic(i_row,jjj,1)
                check_yz_wing = 1
            ELSE IF (sudoku_logic(i_row,jjj,2) .eq. cell_value(2) .AND. &
                        sudoku_logic(i_row,jjj,1) .eq. Z_value) THEN
                Y_value = sudoku_logic(i_row,jjj,2)
                check_yz_wing = 1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------
              ! Find buddies of ii_other1, jj_other1
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = jj_other1
                END DO

              IF (mod(ii_other1,3) .ne. 0) THEN
                 small_cell_row = int(ii_other1/3)+1
              ELSE
                 small_cell_row = int(ii_other1/3)
              END IF
              IF (mod(jj_other1,3) .ne. 0) THEN
                 small_cell_column = int(jj_other1/3)+1
              ELSE
                 small_cell_column = int(jj_other1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other1) CYCLE
                  IF (jj_other2 .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

               ! Find buddies of i_row and jjj
                buddy=0
                DO j=1,9
                  IF (j .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i_row
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. i_row) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jjj
                END DO

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(jjj,3) .ne. 0) THEN
                 small_cell_column = int(jjj/3)+1
              ELSE
                 small_cell_column = int(jjj/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. i_row) CYCLE
                  IF (jj_other2 .eq. jjj) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO

!-----------------------------------------------------------------------
            END IF
         END DO

! Loop over the rows of j_column
         DO iii=1,9
           check_yz_wing=0
           IF (iii .eq. i_row) CYCLE
             IF (sudoku(iii,j_column) .ne. 0) CYCLE
             cell_k_numbers=sudoku_logic_numbers(iii,j_column)
             IF (cell_k_numbers .ne. 2) CYCLE

             IF (sudoku_logic(iii,j_column,1) .eq. cell_value(2) .AND. &
                        sudoku_logic(iii,j_column,2) .eq. Z_value) THEN
                Y_value = sudoku_logic(iii,j_column,1)
                check_yz_wing = 1
             ELSE IF (sudoku_logic(iii,j_column,2) .eq. cell_value(2) .AND. &
                        sudoku_logic(iii,j_column,1) .eq. Z_value) THEN
                Y_value = sudoku_logic(iii,j_column,2)
                check_yz_wing = 1
             END IF

            IF (check_yz_wing .eq. 1) THEN

                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------------
              ! Find buddies of ii_other1, jj_other1
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = jj_other1
                END DO

              IF (mod(ii_other1,3) .ne. 0) THEN
                 small_cell_row = int(ii_other1/3)+1
              ELSE
                 small_cell_row = int(ii_other1/3)
              END IF
              IF (mod(jj_other1,3) .ne. 0) THEN
                 small_cell_column = int(jj_other1/3)+1
              ELSE
                 small_cell_column = int(jj_other1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other1) CYCLE
                  IF (jj_other2 .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

                ! Find buddies of iii and j_column
                buddy=0
                DO j=1,9
                  IF (j .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = iii
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. iii) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = j_column
                END DO


              IF (mod(iii,3) .ne. 0) THEN
                 small_cell_row = int(iii/3)+1
              ELSE
                 small_cell_row = int(iii/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. iii) CYCLE
                  IF (jj_other2 .eq. j_column) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
             DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO

!-----------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  check_yz_wing = 0

                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
		  IF ((ii_other .eq. ii_other1) .AND. (jj_other .eq. jj_other1)) CYCLE
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE

                  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE

                  IF (sudoku_logic(ii_other,jj_other,1) .eq. cell_value(2) .AND. &
                                sudoku_logic(ii_other,jj_other,2) .eq. Z_value) THEN
                        Y_value = sudoku_logic(ii_other,jj_other,1)
                        check_yz_wing = 1
                  ELSE IF (sudoku_logic(ii_other,jj_other,2) .eq. cell_value(2) .AND. &
                                sudoku_logic(ii_other,jj_other,1) .eq. Z_value) THEN
                         Y_value = sudoku_logic(ii_other,jj_other,2)
                         check_yz_wing = 1
                  END IF

                  IF (check_yz_wing .eq. 1) THEN
                        ! Remove Z_value from the buddies of xz and yz squares
                        ! IMP: Should we return to the original square if we find a XY wing


!--------------------------------------------------------------------------------
              ! Find buddies of ii_other1, jj_other1
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = jj_other1
                END DO

              IF (mod(ii_other1,3) .ne. 0) THEN
                 small_cell_row = int(ii_other1/3)+1
              ELSE
                 small_cell_row = int(ii_other1/3)
              END IF
              IF (mod(jj_other1,3) .ne. 0) THEN
                 small_cell_column = int(jj_other1/3)+1
              ELSE
                 small_cell_column = int(jj_other1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other1) CYCLE
                  IF (jj_other2 .eq. jj_other1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

              ! Find buddies of ii_other, jj_other
                buddy=0
                DO j=1,9
                  IF (j .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. ii_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = jj_other
                END DO

              IF (mod(ii_other,3) .ne. 0) THEN
                 small_cell_row = int(ii_other/3)+1
              ELSE
                 small_cell_row = int(ii_other/3)
              END IF
              IF (mod(jj_other,3) .ne. 0) THEN
                 small_cell_column = int(jj_other/3)+1
              ELSE
                 small_cell_column = int(jj_other/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. ii_other) CYCLE
                  IF (jj_other2 .eq. jj_other) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO

                buddy_xy=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_y_buddy = buddies_row_Y(jbuddy)
                  column_y_buddy = buddies_column_Y(jbuddy)
        IF ((row_x_buddy .eq. row_y_buddy) .AND. (column_x_buddy .eq. column_y_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_x_buddy
                  buddies_column_XY(buddy_xy) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO


! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

!-------------------------------------------------------------------------------
                  END IF

                END DO
              END DO
! End If over xy wing
	   END IF
! End over ii_other1 and jj_other1
	END DO
      END DO

! End loop over squares of i_row and j_column	
       END DO
     END DO	

		
	      	  
END SUBROUTINE XY_wings

!-------------------------------------------------------------------------------------
! initial-34 is used to test XYZ_wings
!------------------------------------------------------------------------------------

SUBROUTINE XYZ_wings

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i_row,j_column,small_cell_row,small_cell_column,m
  INTEGER,DIMENSION(3) :: cell_value
  INTEGER :: cell_ij_numbers,cell_k_numbers
  INTEGER :: check_xz_wing,check_yz_wing,check_xyz_wing
  INTEGER :: ii_other,jj_other,iii,jj,jjj,ii,i
  INTEGER :: Y_value,Z_value,X_value
  INTEGER :: check_block,iblock_column,iblock_row,iblock,check_value
  INTEGER :: ii_other1,jj_other1
  INTEGER,DIMENSION(9) :: cell_value_xyz_wings1,cell_value_xyz_wings2,cell_value_xyz_wings3
  INTEGER :: temp_number1,temp_number2,temp_number3
  INTEGER :: row1,column1,row2,column2,row3,column3
  INTEGER,DIMENSION(25) :: buddies_row_X,buddies_row_Y,buddies_row_XY
  INTEGER,DIMENSION(25) :: buddies_row_Z,buddies_row_XZ
  INTEGER,DIMENSION(25) :: buddies_column_X,buddies_column_Y,buddies_column_XY
  INTEGER,DIMENSION(25) :: buddies_column_Z,buddies_column_XZ
  INTEGER,DIMENSION(9) :: temp_array
  INTEGER :: temp_number,inumber,knumber
  INTEGER :: buddy,buddy_xy,column_buddy_xy,row_buddy_xy
  INTEGER :: column_x_buddy,column_y_buddy,ibuddy,row_x_buddy,row_y_buddy
  INTEGER :: cell_ij_logic_number,j,jbuddy
  INTEGER :: ii_other2,jj_other2
  INTEGER :: buddy_xz,column_xz_buddy,column_z_buddy,row_xz_buddy,row_z_buddy


  ! For each square
  DO i_row=1,9
    DO j_column=1,9

      cell_value_xyz_wings1 = 0
      IF (sudoku(i_row,j_column) .ne. 0) CYCLE
      cell_ij_numbers=sudoku_logic_numbers(i_row,j_column)

      IF (cell_ij_numbers .ne. 3) CYCLE
      cell_value(1) = sudoku_logic(i_row,j_column,1)
      cell_value(2) = sudoku_logic(i_row,j_column,2)
      cell_value(3) = sudoku_logic(i_row,j_column,3)

      cell_value_xyz_wings1(cell_value(1)) = 1
      cell_value_xyz_wings1(cell_value(2)) = 1
      cell_value_xyz_wings1(cell_value(3)) = 1

      ! Loop over columns of i_row 
      DO jj=1,9
        check_xz_wing=0
	check_xyz_wing=0
	cell_value_xyz_wings2=cell_value_xyz_wings1
        IF (jj .eq. j_column) CYCLE
        IF (sudoku(i_row,jj) .ne. 0) CYCLE
	cell_k_numbers=sudoku_logic_numbers(i_row,jj)
        IF (cell_k_numbers .ne. 2) CYCLE

	cell_value_xyz_wings2(sudoku_logic(i_row,jj,1)) = cell_value_xyz_wings2(sudoku_logic &
			(i_row,jj,1))+1
	cell_value_xyz_wings2(sudoku_logic(i_row,jj,2)) = cell_value_xyz_wings2(sudoku_logic &
			(i_row,jj,2))+1

        temp_number1=0
	temp_number2=0
	temp_number3=0
	DO i=1,9
	  IF (cell_value_xyz_wings2(i) .eq. 1) THEN
		temp_number1=temp_number1+1
	  END IF
	  IF (cell_value_xyz_wings2(i) .eq. 2) THEN
		temp_number2=temp_number2+1
	  END IF
	  IF (cell_value_xyz_wings2(i) .eq. 3) THEN
		temp_number3=temp_number3+1
	  END IF
	END DO

	IF ((temp_number1 .eq. 1) .AND. (temp_number2 .eq. 2)) THEN
		check_xz_wing=1
	END IF

	IF (check_xz_wing .eq. 1) THEN
	  ! Loop over the columns of i_row
	  DO jjj=1,9
	    check_yz_wing=0
	    cell_value_xyz_wings3=cell_value_xyz_wings2
            IF (jjj .eq. j_column) CYCLE
            IF (jjj .eq. jj) CYCLE
            IF (sudoku(i_row,jjj) .ne. 0) CYCLE
            cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
            IF (cell_k_numbers .ne. 2) CYCLE

	    cell_value_xyz_wings3(sudoku_logic(i_row,jjj,1))=cell_value_xyz_wings3(sudoku_logic &
				(i_row,jjj,1))+1
	    cell_value_xyz_wings3(sudoku_logic(i_row,jjj,2))=cell_value_xyz_wings3(sudoku_logic &
				(i_row,jjj,2))+1
	
	    temp_number1=0
	    temp_number2=0
	    temp_number3=0
	    DO i=1,9
	       IF (cell_value_xyz_wings3(i) .eq. 1) THEN
		 temp_number1=temp_number1+1
	       END IF
	       IF (cell_value_xyz_wings3(i) .eq. 2) THEN
		 temp_number2=temp_number2+1
	       END IF
	       IF (cell_value_xyz_wings3(i) .eq. 3) THEN
		 temp_number3=temp_number3+1
		 Z_value=i
	       END IF
	    END DO

	    IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
		check_yz_wing=1
	    END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=i_row
		column2=jj
		row3=i_row
		column3=jjj

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO


              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!-------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the rows of j_column
	 DO iii=1,9
	   check_yz_wing=0
	   cell_value_xyz_wings3=cell_value_xyz_wings2
           IF (iii .eq. i_row) CYCLE
           IF (sudoku(iii,j_column) .ne. 0) CYCLE
           cell_k_numbers=sudoku_logic_numbers(iii,j_column)
           IF (cell_k_numbers .ne. 2) CYCLE

            cell_value_xyz_wings3(sudoku_logic(iii,j_column,1))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,1))+1
            cell_value_xyz_wings3(sudoku_logic(iii,j_column,2))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=i_row
		column2=jj
		row3=iii
		column3=j_column

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF


              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO

              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO

!------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  check_yz_wing = 0
		   cell_value_xyz_wings3=cell_value_xyz_wings2

                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE

                  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE

    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,1))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,1))+1
    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,2))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!----------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=i_row
		column2=jj
		row3=ii_other
		column3=jj_other

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO


              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO


!--------------------------------------------------------------------------------
            END IF

                END DO
              END DO
! End If over xy wing
            END IF
! End loop over columns of i_row
         END DO

! Loop over rows of j_column
        DO ii=1,9
          check_xz_wing=0
	  check_xyz_wing=0
	  cell_value_xyz_wings2=cell_value_xyz_wings1
          IF (ii .eq. i_row) CYCLE
          IF (sudoku(ii,j_column) .ne. 0) CYCLE
          cell_k_numbers=sudoku_logic_numbers(ii,j_column)
          IF (cell_k_numbers .ne. 2) CYCLE

        cell_value_xyz_wings2(sudoku_logic(ii,j_column,1)) = cell_value_xyz_wings2(sudoku_logic &
                        (ii,j_column,1))+1
        cell_value_xyz_wings2(sudoku_logic(ii,j_column,2)) = cell_value_xyz_wings2(sudoku_logic &
                        (ii,j_column,2))+1

        temp_number1=0
        temp_number2=0
        temp_number3=0
        DO i=1,9
          IF (cell_value_xyz_wings2(i) .eq. 1) THEN
                temp_number1=temp_number1+1
          END IF
          IF (cell_value_xyz_wings2(i) .eq. 2) THEN
                temp_number2=temp_number2+1
          END IF
          IF (cell_value_xyz_wings2(i) .eq. 3) THEN
                temp_number3=temp_number3+1
          END IF
        END DO

        IF ((temp_number1 .eq. 1) .AND. (temp_number2 .eq. 2)) THEN
                check_xz_wing=1
        END IF

        IF (check_xz_wing .eq. 1) THEN
          ! Loop over the columns of i_row
          DO jjj=1,9
            check_yz_wing=0
            cell_value_xyz_wings3=cell_value_xyz_wings2
            IF (jjj .eq. j_column) CYCLE
            IF (sudoku(i_row,jjj) .ne. 0) CYCLE
            cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
            IF (cell_k_numbers .ne. 2) CYCLE

            cell_value_xyz_wings3(sudoku_logic(i_row,jjj,1))=cell_value_xyz_wings3(sudoku_logic &
                                (i_row,jjj,1))+1
            cell_value_xyz_wings3(sudoku_logic(i_row,jjj,2))=cell_value_xyz_wings3(sudoku_logic &
                                (i_row,jjj,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii
		column2=j_column
		row3=i_row
		column3=jjj

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO

                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO


              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO


             END DO


!-------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the rows of j_column
         DO iii=1,9
           check_yz_wing=0
	   cell_value_xyz_wings3=cell_value_xyz_wings2
           IF (iii .eq. i_row) CYCLE
           IF (iii .eq. ii) CYCLE
             IF (sudoku(iii,j_column) .ne. 0) CYCLE
             cell_k_numbers=sudoku_logic_numbers(iii,j_column)
             IF (cell_k_numbers .ne. 2) CYCLE

            cell_value_xyz_wings3(sudoku_logic(iii,j_column,1))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,1))+1
            cell_value_xyz_wings3(sudoku_logic(iii,j_column,2))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

		
!-----------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii
		column2=j_column
		row3=iii
		column3=j_column

               ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column
              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO

              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO

!----------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  check_yz_wing = 0
                   cell_value_xyz_wings3=cell_value_xyz_wings2

                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE

                  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE

    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,1))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,1))+1
    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,2))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!--------------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii
		column2=j_column
		row3=ii_other
		column3=jj_other

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO


              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO



              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO



! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!--------------------------------------------------------------------------------------
            END IF

                END DO
              END DO
! End If over xy wing
            END IF
! End loop over columns of j_column 
         END DO


! Do for blocks
! Loop over blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other1=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other1=(iblock_column-1)*3+1,(iblock_column*3)

                   check_xz_wing=0
		   cell_value_xyz_wings2=cell_value_xyz_wings1
                   IF ((ii_other1 .eq. i_row) .AND. (jj_other1 .eq. j_column)) CYCLE
                   IF (sudoku(ii_other1,jj_other1) .ne. 0) CYCLE
                   cell_k_numbers=sudoku_logic_numbers(ii_other1,jj_other1)
                   IF (cell_k_numbers .ne. 2) CYCLE

  cell_value_xyz_wings2(sudoku_logic(ii_other1,jj_other1,1)) = cell_value_xyz_wings2(sudoku_logic &
                        (ii_other1,jj_other1,1))+1
  cell_value_xyz_wings2(sudoku_logic(ii_other1,jj_other1,2)) = cell_value_xyz_wings2(sudoku_logic &
                        (ii_other1,jj_other1,2))+1

        temp_number1=0
        temp_number2=0
        temp_number3=0
        DO i=1,9
          IF (cell_value_xyz_wings2(i) .eq. 1) THEN
                temp_number1=temp_number1+1
          END IF
          IF (cell_value_xyz_wings2(i) .eq. 2) THEN
                temp_number2=temp_number2+1
          END IF
          IF (cell_value_xyz_wings2(i) .eq. 3) THEN
                temp_number3=temp_number3+1
          END IF
        END DO

        IF ((temp_number1 .eq. 1) .AND. (temp_number2 .eq. 2)) THEN
                check_xz_wing=1
        END IF

        IF (check_xz_wing .eq. 1) THEN
          ! Loop over the columns of i_row
          DO jjj=1,9
            check_yz_wing=0
            cell_value_xyz_wings3=cell_value_xyz_wings2
            IF (jjj .eq. j_column) CYCLE
            IF (sudoku(i_row,jjj) .ne. 0) CYCLE
            cell_k_numbers=sudoku_logic_numbers(i_row,jjj)
            IF (cell_k_numbers .ne. 2) CYCLE

            cell_value_xyz_wings3(sudoku_logic(i_row,jjj,1))=cell_value_xyz_wings3(sudoku_logic &
                                (i_row,jjj,1))+1
            cell_value_xyz_wings3(sudoku_logic(i_row,jjj,2))=cell_value_xyz_wings3(sudoku_logic &
                                (i_row,jjj,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii_other1
		column2=jj_other1
		row3=i_row
		column3=jjj

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column
              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO

              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!-------------------------------------------------------------------------------
            END IF
         END DO

! Loop over the rows of j_column
         DO iii=1,9
           check_yz_wing=0
           cell_value_xyz_wings3=cell_value_xyz_wings2
           IF (iii .eq. i_row) CYCLE
             IF (sudoku(iii,j_column) .ne. 0) CYCLE
             cell_k_numbers=sudoku_logic_numbers(iii,j_column)
             IF (cell_k_numbers .ne. 2) CYCLE

            cell_value_xyz_wings3(sudoku_logic(iii,j_column,1))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,1))+1
            cell_value_xyz_wings3(sudoku_logic(iii,j_column,2))=cell_value_xyz_wings3(sudoku_logic &
                                (iii,j_column,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!-----------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii_other
		column2=jj_other
		row3=iii
		column3=j_column

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column
              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO

              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!-----------------------------------------------------------------------------
            END IF
         END DO

! Loop over the blocks of i_row and j_column

              IF (mod(i_row,3) .ne. 0) THEN
                 small_cell_row = int(i_row/3)+1
              ELSE
                 small_cell_row = int(i_row/3)
              END IF
              IF (mod(j_column,3) .ne. 0) THEN
                 small_cell_column = int(j_column/3)+1
              ELSE
                 small_cell_column = int(j_column/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

             DO ii_other=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other=(iblock_column-1)*3+1,(iblock_column*3)
                  check_yz_wing = 0
                   cell_value_xyz_wings3=cell_value_xyz_wings2

                  IF ((ii_other .eq. i_row) .AND. (jj_other .eq. j_column)) CYCLE
		  IF ((ii_other .eq. ii_other1) .AND. (jj_other .eq. jj_other1)) CYCLE
                  IF (sudoku(ii_other,jj_other) .ne. 0) CYCLE

                  cell_k_numbers = sudoku_logic_numbers(ii_other,jj_other)
                  IF (cell_k_numbers .ne. 2) CYCLE

    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,1))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,1))+1
    cell_value_xyz_wings3(sudoku_logic(ii_other,jj_other,2))=cell_value_xyz_wings3(sudoku_logic &
                                (ii_other,jj_other,2))+1

            temp_number1=0
            temp_number2=0
            temp_number3=0
            DO i=1,9
               IF (cell_value_xyz_wings3(i) .eq. 1) THEN
                 temp_number1=temp_number1+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 2) THEN
                 temp_number2=temp_number2+1
               END IF
               IF (cell_value_xyz_wings3(i) .eq. 3) THEN
                 temp_number3=temp_number3+1
                 Z_value=i
               END IF
            END DO

            IF ((temp_number2 .eq. 2) .AND. (temp_number3 .eq. 1)) THEN
                check_yz_wing=1
            END IF

            IF (check_yz_wing .eq. 1) THEN
                ! Remove Z_value from the buddies of xz and yz squares
                ! IMP: Should we return to the original square if we find a XY wing

!---------------------------------------------------------------------------------
		row1=i_row
		column1=j_column
		row2=ii_other1
		column2=jj_other1
		row3=ii_other
		column3=jj_other

                ! Find buddies of row1 and column1
                buddy=0
                DO j=1,9
                  IF (j .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = row1
                  buddies_column_X(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = i
                  buddies_column_X(buddy) = column1
                END DO

              IF (mod(row1,3) .ne. 0) THEN
                 small_cell_row = int(row1/3)+1
              ELSE
                 small_cell_row = int(row1/3)
              END IF
              IF (mod(column1,3) .ne. 0) THEN
                 small_cell_column = int(column1/3)+1
              ELSE
                 small_cell_column = int(column1/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF
              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row1) CYCLE
                  IF (jj_other2 .eq. column1) CYCLE
                  buddy=buddy+1
                  buddies_row_X(buddy) = ii_other2
                  buddies_column_X(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row2 and column2
                buddy=0
                DO j=1,9
                  IF (j .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = row2
                  buddies_column_Y(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = i
                  buddies_column_Y(buddy) = column2
                END DO

              IF (mod(row2,3) .ne. 0) THEN
                 small_cell_row = int(row2/3)+1
              ELSE
                 small_cell_row = int(row2/3)
              END IF
              IF (mod(column2,3) .ne. 0) THEN
                 small_cell_column = int(column2/3)+1
              ELSE
                 small_cell_column = int(column2/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column
             iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row2) CYCLE
                  IF (jj_other2 .eq. column2) CYCLE
                  buddy=buddy+1
                  buddies_row_Y(buddy) = ii_other2
                  buddies_column_Y(buddy) = jj_other2
                END DO
              END DO


                ! Find buddies of row3 and column3
                buddy=0
                DO j=1,9
                  IF (j .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = row3
                  buddies_column_Z(buddy) = j
                END DO
                DO i=1,9
                  IF (i .eq. row3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = i
                  buddies_column_Z(buddy) = column3
                END DO

              IF (mod(row3,3) .ne. 0) THEN
                 small_cell_row = int(row3/3)+1
              ELSE
                 small_cell_row = int(row3/3)
              END IF
              IF (mod(column3,3) .ne. 0) THEN
                 small_cell_column = int(column3/3)+1
              ELSE
                 small_cell_column = int(column3/3)
              END IF
              check_block = (small_cell_row-1)*3+small_cell_column

              iblock_column=mod(check_block,3)
              IF (iblock_column .ne. 0) THEN
                iblock_row = (check_block/3)+1
              ELSE
                iblock_row = (check_block/3)
              END IF
              IF (iblock_column .eq. 0) THEN
                iblock_column=3
              END IF

              DO ii_other2=(iblock_row-1)*3+1,(iblock_row*3)
                DO jj_other2=(iblock_column-1)*3+1,(iblock_column*3)

                  IF (ii_other2 .eq. row3) CYCLE
                  IF (jj_other2 .eq. column3) CYCLE
                  buddy=buddy+1
                  buddies_row_Z(buddy) = ii_other2
                  buddies_column_Z(buddy) = jj_other2
                END DO
              END DO


              buddy_xz=0
              DO ibuddy=1,20
                row_x_buddy = buddies_row_X(ibuddy)
                column_x_buddy = buddies_column_X(ibuddy)
                DO jbuddy=1,20
                  row_z_buddy = buddies_row_Z(jbuddy)
                  column_z_buddy = buddies_column_Z(jbuddy)
        IF ((row_x_buddy .eq. row_z_buddy) .AND. (column_x_buddy .eq. column_z_buddy)) THEN
                  buddy_xz=buddy_xz+1
                  buddies_row_XZ(buddy_xz) = row_x_buddy
                  buddies_column_XZ(buddy_xz) = column_x_buddy
                  EXIT
        END IF
                END DO
              END DO

              buddy_xy=0
              DO ibuddy=1,20
                row_y_buddy = buddies_row_Y(ibuddy)
                column_y_buddy = buddies_column_Y(ibuddy)
                DO jbuddy=1,buddy_xz
                  row_xz_buddy = buddies_row_XZ(jbuddy)
                  column_xz_buddy = buddies_column_XZ(jbuddy)
        IF ((row_y_buddy .eq. row_xz_buddy) .AND. (column_y_buddy .eq. column_xz_buddy)) THEN
                  buddy_xy=buddy_xy+1
                  buddies_row_XY(buddy_xy) = row_y_buddy
                  buddies_column_XY(buddy_xy) = column_y_buddy
                  EXIT
        END IF
                END DO
              END DO

! Remove the number Z_value from the common buddies
              DO ibuddy=1,buddy_xy
                 row_buddy_xy = buddies_row_XY(ibuddy)
                 column_buddy_xy = buddies_column_XY(ibuddy)
                 temp_array=0
                 temp_number=0
                 IF (sudoku(row_buddy_xy,column_buddy_xy) .ne. 0) CYCLE
                 cell_ij_numbers = sudoku_logic_numbers(row_buddy_xy,column_buddy_xy)
                 DO inumber=1,cell_ij_numbers
                   cell_ij_logic_number=sudoku_logic(row_buddy_xy,column_buddy_xy,inumber)
                   IF (cell_ij_logic_number .eq. Z_value) CYCLE
                   temp_number = temp_number+1
                   temp_array(temp_number) = cell_ij_logic_number
                 END DO

               ! Print out the values

                 DO knumber=1,cell_ij_numbers
                  sudoku_logic(row_buddy_xy,column_buddy_xy,knumber)=0
                 END DO
                 sudoku_logic_numbers(row_buddy_xy,column_buddy_xy) = temp_number
                 DO knumber=1,temp_number
                   sudoku_logic(row_buddy_xy,column_buddy_xy,knumber) = temp_array(knumber)
                 END DO

             END DO


!----------------------------------------------------------------------------------
            END IF

                END DO
              END DO
! End If over xy wing
           END IF
! End over ii_other1 and jj_other1
        END DO
      END DO

! End loop over squares of i_row and j_column
       END DO
     END DO

END SUBROUTINE XYZ_wings
!---------------------------------------------------------------------------------

