
!-------------------------------------------------------------------------------
! This program solves a sudoku puzzle (using Logic)
!-------------------------------------------------------------------------------

MODULE global_variables
  
   INTEGER, DIMENSION(9,9) :: sudoku
   INTEGER, DIMENSION(3,3,3,3) :: smallcell
   INTEGER, DIMENSION(9,9) :: sudoku_initial
   INTEGER :: i_initial,j_initial

   INTEGER, DIMENSION(9,9,9) :: sudoku_logic,sudoku_logic_initial
   INTEGER, DIMENSION(9,9) :: sudoku_logic_numbers

   INTEGER, DIMENSION(9) :: naked_pair_global
   ! Simple hidden set can be 2 or 3.. it cannot have more than 3 numbers
   INTEGER, DIMENSION(3) :: simple_hidden_set
  
   INTEGER,DIMENSION(2:9,9*9) :: naked_pair_list_global
   INTEGER,DIMENSION(3,9*9) :: simple_hidden_set_global

   INTEGER :: solved_cells

   INTEGER,DIMENSION(81) :: forcing_loop_stack_row,forcing_loop_stack_column
   INTEGER,DIMENSION(81) :: forcing_loop_stack_value
   INTEGER :: forcing_loop_stack_length
   INTEGER :: forcing_loop_check
   INTEGER :: forcing_loop_initial_value 
   INTEGER,DIMENSION(9) :: forcing_loop_row,forcing_loop_column,forcing_loop_block
   INTEGER :: forcing_chain_check,forcing_loop_start_block
   INTEGER,PARAMETER :: forcing_chain_stack_length_max = 10
   INTEGER :: forcing_chain_stack_check 

   INTEGER :: check_bowman_next
   INTEGER :: i_bowman_check,j_bowman_check
   INTEGER,PARAMETER :: bowman_array_length_max = 15
   INTEGER :: check_bowman_numbers

   INTEGER :: check_nishio_next
   INTEGER :: i_nishio_check,j_nishio_check
   INTEGER :: check_nishio_numbers

!   INTEGER, DIMENSION(9,9) :: sudoku_orig1
!   INTEGER, DIMENSION(9,9,9) :: sudoku_orig1_logic
!   INTEGER, DIMENSION(9,9) :: sudoku_orig1_logic_numbers
   ! 81 is the maximum number of states possible
   INTEGER, DIMENSION(81,9,9) :: sudoku_Adrianne
   INTEGER, DIMENSION(81,9,9,9) :: sudoku_Adrianne_logic
   INTEGER, DIMENSION(81,9,9) :: sudoku_Adrianne_logic_numbers
   INTEGER, DIMENSION(81) :: Adrianne_state_row
   INTEGER, DIMENSION(81) :: Adrianne_state_col
   INTEGER, DIMENSION(81) :: Adrianne_state_sudoku_logic_number
   INTEGER :: nAdrianneStates

   ! 81 is the maximum number of states possible
   ! 81 is the maximum number of snapshots possible
!   INTEGER, DIMENSION(81,81,9,9) :: sudoku_snapshot_states
   ! initial snapshots before we start Adrianne's thread method
   INTEGER, DIMENSION(81,9,9) :: sudoku_snapshot_initial
   INTEGER,DIMENSION(100) :: snapshots_initial
   INTEGER,DIMENSION(100) :: duplicate_snapshots

   INTEGER :: try_nishio,try_bowman_bingo


END MODULE global_variables

!-----------------------------------------------------------------------------

SUBROUTINE initialize_puzzle

 USE global_variables
 IMPLICIT NONE

 INTEGER :: i,j,ith,jth,checking
 INTEGER :: small_cell_row,small_cell_column

  INTEGER :: kk,ll
  INTEGER :: k,l,m,n,ii,jj,iii,jjj,iiii
  INTEGER,DIMENSION(9) :: value1,value2,value3
  INTEGER :: value_cells1,value_cells2,value_cells3

  DO i=1,9
    DO j=1,9
       sudoku(i,j) = 0
       sudoku_initial(i,j) = 0
    END DO
  END DO

  !COM: Initialise the logical cells of sudoku
  sudoku_logic = 0
  sudoku_logic_initial = 0
  sudoku_logic_numbers = 0

  DO i=1,3
    DO j=1,3
	smallcell(1,1,i,j) = 0
	smallcell(1,2,i,j) = 0
	smallcell(1,3,i,j) = 0
	smallcell(2,1,i,j) = 0
	smallcell(2,2,i,j) = 0
	smallcell(2,3,i,j) = 0
	smallcell(3,1,i,j) = 0
	smallcell(3,2,i,j) = 0
	smallcell(3,3,i,j) = 0
     END DO
  END DO

  checking = 0
  OPEN(UNIT=10,FILE='initial',STATUS='OLD',ACCESS='SEQUENTIAL',ACTION='READ')
  !COM: Read Sudoku values one at a time (row wise i.e. there will be (9X9) 81 values)
  DO i=1,9
         READ(10,*) sudoku(i,1),sudoku(i,2),sudoku(i,3),sudoku(i,4),sudoku(i,5),&
		    sudoku(i,6),sudoku(i,7),sudoku(i,8),sudoku(i,9)
         sudoku_initial(i,1) = sudoku(i,1)
         sudoku_initial(i,2) = sudoku(i,2)
         sudoku_initial(i,3) = sudoku(i,3)
         sudoku_initial(i,4) = sudoku(i,4)
         sudoku_initial(i,5) = sudoku(i,5)
         sudoku_initial(i,6) = sudoku(i,6)
         sudoku_initial(i,7) = sudoku(i,7)
         sudoku_initial(i,8) = sudoku(i,8)
         sudoku_initial(i,9) = sudoku(i,9)
     DO j=1,9
	 IF (mod(i,3) .ne. 0) THEN
		small_cell_row = int(i/3) + 1
	 ELSE
		small_cell_row = int(i/3)
	 END IF
	 IF (mod(j,3) .ne. 0) THEN
		small_cell_column = int(j/3) + 1
	 ELSE
		small_cell_column = int(j/3)
	 END IF
	 ith = mod(i,3)
	 jth = mod(j,3)
	 IF (ith  == 0) then 
		ith = 3
	 END IF
	 IF (jth == 0) then 
		jth = 3
	 END IF
	 smallcell(small_cell_row,small_cell_column,ith,jth) = sudoku(i,j)
    END DO
  END DO

  !COM: Initialise the sudoku logical cells

  DO i=1,9
    DO j=1,9
	IF (sudoku(i,j) .ne. 0) CYCLE
	value1 = 0
	value2 = 0
	value3 = 0

	value_cells1 = 0
	value_cells2 = 0
	value_cells3 = 0


! Find out what numbers are present in the small cell and the total number of
! cells occupied
                IF (mod(i,3) .ne. 0) THEN
                        small_cell_row = int(i/3)+1
                ELSE
                        small_cell_row = int(i/3)
                END IF
                IF (mod(j,3) .ne. 0) THEN
                        small_cell_column = int(j/3)+1
                ELSE
                        small_cell_column = int(j/3)
                END IF

              DO ii=1,9
                DO k=1,3
                  DO l=1,3
                        IF (smallcell(small_cell_row,small_cell_column,k,l) .eq. ii) THEN
!                               m=(k-1)*3+l
                                !COM: Value1 is a one dimensiona array of 9 cells.
                                value1(ii) = 1
                                value_cells1 = value_cells1+1
                                !COM: Here Exit should get out of kloop and the execution
                                !COM: should go to ii loop..
                                EXIT
                        END IF
                   END DO
                END DO
              END DO

! Find out what numbers are present in the column and the total number of cells occupied
                DO ii=1,9
                  DO k=1,9
                        IF (sudoku(i,k) .eq. ii) THEN
                                value2(ii) = 1
                                value_cells2 = value_cells2+1
                                EXIT
                        END IF
                  END DO
                END DO

! Find out what numbers are present in the row and the total number of cells occupied
                DO ii=1,9
                  DO l=1,9
                        IF (sudoku(l,j) .eq. ii) THEN
                                value3(ii) = 1
                                value_cells3 = value_cells3+1
                                EXIT
                        END IF
                  END DO
                END DO

	!COM: Populate the logical cells of the sudoku
	DO ii=1,9
	  IF ((value1(ii) .eq. 0) .AND. (value2(ii) .eq. 0) .AND. (value3(ii) .eq. 0)) THEN
		sudoku_logic_numbers(i,j) = sudoku_logic_numbers(i,j) + 1
		sudoku_logic(i,j,sudoku_logic_numbers(i,j)) = ii
	  END IF
    	END DO	

    END DO
 END DO

 solved_cells = 0
 DO i=1,9
   DO j=1,9
     IF (sudoku(i,j) .ne. 0) THEN
       solved_cells = solved_cells+1
     END IF
   END DO
 END DO

!  OPEN(UNIT=20,FILE='initial-tricks',STATUS='OLD',ACCESS='SEQUENTIAL',ACTION='READ')
!  READ(20,*) 
!  READ(20,*) try_nishio
!  READ(20,*)
!  READ(20,*) try_bowman_bingo
!  CLOSE(UNIT=20)

END SUBROUTINE initialize_puzzle
!--------------------------------------------------------------------------------

PROGRAM sudoku_solver

  USE global_variables
  IMPLICIT NONE

  INTEGER :: i,j
  INTEGER :: check,step
  INTEGER :: solved_cells_initial,solved_cells_final
  INTEGER :: i_bowman,i_nishio
  INTEGER :: icell,jcell,check_number
  INTEGER :: check_adrianne
  INTEGER :: snapshots
  INTEGER :: count_snapshots
  INTEGER :: check1


  CALL initialize_puzzle 

  write(*,*) 'The Sudoku puzzle as entered (to be solved) is :'
  DO i=1,9
       write(*,*) sudoku(i,1),sudoku(i,2),sudoku(i,3),sudoku(i,4),sudoku(i,5),sudoku(i,6),&
                   sudoku(i,7),sudoku(i,8),sudoku(i,9)
        write(*,*)
  END DO

  snapshots = 0

333 CONTINUE

  check = 0
  solved_cells = 0
  check1 = 0

  DO while ((solved_cells .lt. 82) .AND. (check1 .lt. 2))
!  DO while (solved_cells .lt. 82) 

    check = check+1
    solved_cells_initial=solved_cells
    CALL Forced_moves 
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN 
        CALL update_snapshots(snapshots)
	check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


    CALL Naked_pairs
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

    CALL Simple_hidden_sets
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


    CALL Intersection
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


    CALL Remote_naked_pair
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


  solved_cells_initial = solved_cells
  CALL Forced_moves
  solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
  END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

   CALL Bug_hunting
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type1
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type2
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type2B
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type3
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type3and2
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type3B
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type4
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Unique_rectangle_type4B
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

  CALL Unique_loop_type1_6squares
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


  CALL Unique_loop_type1_8squares
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


  CALL Unique_loop_type2
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


  CALL Unique_loop_type3
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


  CALL Unique_loop_type4
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Simple_Xwing
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Swordfish
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Jellyfish
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


   CALL Squirmbag
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

   CALL XY_wings
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

  
   CALL XYZ_wings
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


!  IF (check .ge. 3) THEN
    CALL simple_forcing_loops
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100


!  END IF

!  IF (check .ge. 4) THEN 
    CALL simple_forcing_chains
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

!  END IF

!  IF (check .ge. 5) THEN
    CALL comprehensive_forcing_chains 
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        CALL update_snapshots(snapshots)
        check = 0
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

!  END IF

!   IF (try_nishio .ne. 0) THEN
!  IF (check .ge. 7) THEN
     check_nishio_next = 0
     i_nishio_check = 1
     j_nishio_check = 1
     check_nishio_numbers = 0

    CALL Nishio
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        check = 0
        CALL update_snapshots(snapshots)
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

! END IF
! END IF

!   IF (try_bowman_bingo .ne. 0) THEN
!  IF (check .ge. 9) THEN
     check_bowman_next = 0
     i_bowman_check = 1
     j_bowman_check = 1
     check_bowman_numbers = 0

    CALL Bowman_bingo
    CALL Pinned_moves
    solved_cells_initial=solved_cells
    CALL Forced_moves
    solved_cells_final=0
    DO i=1,9
      DO j=1,9
        IF (sudoku(i,j) .ne. 0) THEN
         solved_cells_final = solved_cells_final+1
        END IF
     END DO
   END DO
   IF (solved_cells_final .gt. solved_cells_initial) THEN
        check = 0
        CALL update_snapshots(snapshots)
   END IF
   solved_cells=solved_cells_final
   IF (solved_cells_final .eq. 81) GO TO 100

! END IF
! END IF

  check1 = check1+1

  END DO

!------------START Adrianne's Thread code here----------------------

! (1) CAll all the methods of the tricks before calling adrianne trick
! (2) During the first call to Adrianne_thread_state store the sudoku,
!     sudoku_logic_numbers and sudoku_logic values to orig arrays
!  (2a) put a number and start a new adrianne state..
!  (2b) put the sudoku and sudoku logic values to that of this
!       adrianne state
! (3) Check for contradiction 
!      There are two ways to check for contradiction :
!       (i) 2 or more numbers in the same group (row,col and blcok)
!       (ii) If sudoku(i,j)=0 and sudoku_logic_numbers(i,j)=0
! (4) IF (yes) change the number of the last Adrianne state array..
!  (5) IF all the numbers have been exhausted.. remove this state from
!      the Adrianne states..
!      GO TO step 2a
!
!-------------------------------------------------------

  CALL Adrianne_thread_state
  snapshots_initial(nAdrianneStates) = snapshots
  Adrianne_state_sudoku_logic_number(nAdrianneStates) = 1
  icell = Adrianne_state_row(nAdrianneStates)
  jcell = Adrianne_state_col(nAdrianneStates)
  IF (sudoku_logic_numbers(icell,jcell) .eq. 0) THEN
        GO TO 444
  END IF
  check_number = sudoku_logic(icell,jcell,1)
  sudoku(icell,jcell) = check_number
  sudoku_logic_numbers(icell,jcell) = 1
  sudoku_logic(icell,jcell,1) = check_number
  CALL Forced_moves
  CALL Pinned_moves
  CALL Forced_moves
111  CONTINUE
  check_adrianne = 0
  CALL check_Contradiction_Adrianne(sudoku,check_adrianne)
  IF (check_adrianne .eq. 1) THEN
222  CONTINUE
        snapshots = snapshots_initial(nAdrianneStates)
        Adrianne_state_sudoku_logic_number(nAdrianneStates) = &
          Adrianne_state_sudoku_logic_number(nAdrianneStates)+1
          icell = Adrianne_state_row(nAdrianneStates)
          jcell = Adrianne_state_col(nAdrianneStates)
        IF (Adrianne_state_sudoku_logic_number(nAdrianneStates) .le. &
             sudoku_Adrianne_logic_numbers(nAdrianneStates,icell,jcell)) THEN
                check_number=sudoku_Adrianne_logic(nAdrianneStates,icell,jcell, &
                Adrianne_state_sudoku_logic_number(nAdrianneStates))
                sudoku = sudoku_Adrianne(nAdrianneStates,:,:)
                sudoku_logic = &
                        sudoku_Adrianne_logic(nAdrianneStates,:,:,:)
                sudoku_logic_numbers = &
                        sudoku_Adrianne_logic_numbers(nAdrianneStates,:,:)
                sudoku(icell,jcell) = check_number
                sudoku_logic_numbers(icell,jcell) = 1
                sudoku_logic(icell,jcell,1) = check_number
                CALL Forced_moves
                CALL Pinned_moves
                CALL Forced_moves

                GO TO 111
        ELSE
444  CONTINUE
                Adrianne_state_sudoku_logic_number(nAdrianneStates) = 0
                nAdrianneStates = nAdrianneStates-1
                sudoku = sudoku_Adrianne(nAdrianneStates,:,:)
                sudoku_logic = &
                        sudoku_Adrianne_logic(nAdrianneStates,:,:,:)
                sudoku_logic_numbers = &
                        sudoku_Adrianne_logic_numbers(nAdrianneStates,:,:)

                GO TO 222
        END IF
  ELSE
        GO TO 333
  END IF

!------------END Adrianne's Thread code here----------------------

100 CONTINUE

  IF (solved_cells .eq. 81) THEN
    write(*,*) 'WE HAVE A SOLUTION !!!'
    write(*,*) 'Number of snapshots is :',snapshots
    write(*,*)
    duplicate_snapshots = 0
    CALL check_duplicate_snapshots(snapshots)
    count_snapshots=0
    DO j=1,81
        IF (duplicate_snapshots(j) .eq. 2) THEN
                count_snapshots = count_snapshots+1
		write(*,*) 'STEP :',j
                DO i=1,9
                        write(*,*) sudoku_snapshot_initial(j,i,1),&
                         sudoku_snapshot_initial(j,i,2),&
                         sudoku_snapshot_initial(j,i,3),&
                         sudoku_snapshot_initial(j,i,4),&
                         sudoku_snapshot_initial(j,i,5),&
                         sudoku_snapshot_initial(j,i,6),&
                         sudoku_snapshot_initial(j,i,7),&
                         sudoku_snapshot_initial(j,i,8),&
                         sudoku_snapshot_initial(j,i,9)
                        write(*,*)
                END DO
        END IF
    END DO

  ELSE 
    write(*,*) 'SORRY : The sudoku puzzle cannot be solved with the tricks/algorithms implemented here.'
  END IF


END PROGRAM sudoku_solver
	
!----------------------------------------------------------------------------------

SUBROUTINE update_snapshots(snapshots)

   USE global_variables
   IMPLICIT NONE

   INTEGER :: snapshots

        snapshots = snapshots + 1
        sudoku_snapshot_initial(snapshots,:,:) = sudoku(:,:)

END SUBROUTINE update_snapshots

!------------------------------------------------------------------------------

SUBROUTINE check_duplicate_snapshots(snapshots)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: snapshots

  INTEGER :: isnap,jsnap,i,j
  INTEGER :: count

iloop:  DO isnap=1,snapshots-1
     IF (duplicate_snapshots(isnap) .eq. 1) CYCLE iloop
jloop:    DO jsnap=isnap+1,snapshots
    count = 0
     IF (duplicate_snapshots(jsnap) .eq. 1) CYCLE iloop
        DO i=1,9
          DO j=1,9
            IF (sudoku_snapshot_initial(isnap,i,j) .eq. &
                        sudoku_snapshot_initial(jsnap,i,j)) THEN
                                count=count+1
            END IF
          END DO
        END DO
        IF (count .eq. 81) THEN
                duplicate_snapshots(jsnap) = 1
                CYCLE jloop
        ELSE
                duplicate_snapshots(isnap) = 2
        END IF

   END DO jloop
 END DO iloop

 IF (duplicate_snapshots(snapshots) .ne. 1) THEN
        duplicate_snapshots(snapshots) = 2
 END IF

END SUBROUTINE check_duplicate_snapshots

!----------------------------------------------------------------------

